SystemOrganization addCategory: #Marea!
SystemOrganization addCategory: #'Marea-Collections'!
SystemOrganization addCategory: #'Marea-Swapping'!
SystemOrganization addCategory: #'Marea-Proxies'!
SystemOrganization addCategory: #'Marea-Serializers'!
SystemOrganization addCategory: #'Marea-Logging'!
SystemOrganization addCategory: #'Marea-Errors'!

FLPrimitiveCluster subclass: #MARFuelProxyCluster
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Serializers'!

!MARFuelProxyCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 10/4/2011 15:32'!
add: anObject traceWith: anAnalyzer
	"Add an object to the cluster. We know the object doesn't have references."

	objects add: anObject! !

!MARFuelProxyCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 1/4/2012 17:38'!
materializeInstanceWith: aDecoder

	^ (Smalltalk at: aDecoder nextEncodedString asSymbol)
		newProxy mareaProxyID: (aDecoder nextEncodedInt32)! !

!MARFuelProxyCluster methodsFor: 'serialize/materialize' stamp: 'MarianoMartinezPeck 1/4/2012 17:39'!
serializeInstance: aProxy with: anEncoder

	anEncoder encodeString: aProxy mareaClass name.
	anEncoder encodeInt32: aProxy mareaProxyID 
	! !

!ClassDescription methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 2/1/2012 21:29'!
hasProxifiedSubclass
	| directSubclasses |
	directSubclasses := self subclasses.
	^ (directSubclasses anySatisfy: [:each | each mareaIsProxy ])
		ifTrue: [ true ]
		ifFalse: [ directSubclasses anySatisfy: [:each | each hasProxifiedSubclass ] ]! !

!PasteUpMorph methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 1/12/2012 11:06'!
worldState
	^ worldState! !

!FLSerializer methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 1/12/2012 12:31'!
mareaSerialization

	^ serializationFactory := [:anObject :anEncoder | 
		(MARFuelSerialization  
			with: anEncoder
			root: anObject 
			analyzer: self analyzer)
			run;
			yourself ]
	! !

!FLMapper methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 12/19/2011 11:55'!
classAdded: aClass
	"nothing to do by default"! !

!FLMapper methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 12/19/2011 12:05'!
classRemoved: aClass
	"nothing to do by default"! !

!FLMapper methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 12/19/2011 11:50'!
resetForInternalObjects: aCollection
	"nothing to do by default"! !

!FLMapper methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 1/3/2012 14:37'!
resetForSameInternalObjects 
	"nothing to do by default"! !

FLMapper subclass: #MARFuelFullGlobalMapper
	instanceVariableNames: 'instanceSideCluster classSideCluster classVariablesCluster globalsCluster globalAssociationCluster clusterByObject internals'
	classVariableNames: 'GlobalAssociations'
	poolDictionaries: ''
	category: 'Marea-Serializers'!

!MARFuelFullGlobalMapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/18/2011 20:24'!
defaultGlobals
	^ GlobalAssociations ! !

!MARFuelFullGlobalMapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/4/2012 17:04'!
globalNames 

	^ #(
		Display
		World
		Smalltalk
		Transcript
		SourceFiles
		Processor
		ImageImports
		TextConstants
		Undeclared
		SystemOrganization
		Sensor
		ActiveWorld
		ActiveHand)! !

!MARFuelFullGlobalMapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/18/2011 22:43'!
includesGlobalObject: anObject
	^ GlobalAssociations contains: [:each | each value == anObject]
	! !

!MARFuelFullGlobalMapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/13/2012 10:56'!
initialize
		GlobalAssociations := self globalNames collect: [:aSymbol |
		Smalltalk globals associationAt: aSymbol ].
	! !

!MARFuelFullGlobalMapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/4/2012 17:28'!
newWithInternals: internals

	^self basicNew
		initializeWithInternals: internals;
		addGlobalsAndAssociations;
		addClassesAndMetaclassesAndVariables;
		yourself 
		! !

!MARFuelFullGlobalMapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/19/2011 17:34'!
addClassesAndMetaclassesAndVariables

	Smalltalk globals allClassesAndTraitsDo: [:each | 
		self associateBehaviorToCluster: each. 
		].! !

!MARFuelFullGlobalMapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/19/2011 17:14'!
addGlobalsAndAssociations

	GlobalAssociations do: [:anAssoc | 
		clusterByObject at: anAssoc put: globalAssociationCluster.
		clusterByObject at: anAssoc value put: globalsCluster].! !

!MARFuelFullGlobalMapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/1/2012 21:14'!
associateBehaviorToCluster: aBehavior

		clusterByObject at: aBehavior put: instanceSideCluster.
		aBehavior mareaIsProxy 
			ifFalse: [
				clusterByObject at: aBehavior classSide put: classSideCluster.
				aBehavior classPool associationsDo: [ :aBinding | 
				classVariablesCluster bindingsAt: aBinding put: aBehavior.
				clusterByObject at: aBinding put: classVariablesCluster ]]
	! !

!MARFuelFullGlobalMapper methodsFor: 'events' stamp: 'MarianoMartinezPeck 12/19/2011 11:54'!
classAdded: aClass
	self associateBehaviorToCluster: aClass! !

!MARFuelFullGlobalMapper methodsFor: 'events' stamp: 'MarianoMartinezPeck 12/19/2011 11:58'!
classRemoved: aClass
	self removeClass: aClass! !

!MARFuelFullGlobalMapper methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 1/12/2012 12:09'!
initialize
	clusterByObject := LargeIdentityDictionary new.
	internals := OrderedCollection new.
	self initializeClusters.! !

!MARFuelFullGlobalMapper methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 1/12/2012 12:29'!
initializeClusters
	instanceSideCluster := FLGlobalClassCluster newAnalyzing.
	classSideCluster := FLGlobalClassSideCluster newAnalyzing.
	classVariablesCluster := FLGlobalClassPoolAssociationCluster newAnalyzing.
	globalsCluster := FLGlobalValueCluster newAnalyzing.
	globalAssociationCluster := FLGlobalAssociationCluster newAnalyzing.! !

!MARFuelFullGlobalMapper methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 1/12/2012 12:08'!
initializeWithInternals: aCollection

	internals := aCollection.
	self initialize.
! !

!MARFuelFullGlobalMapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/12/2012 17:57'!
mapAndTrace: anObject

  	 (internals identityIncludes: anObject)
		ifTrue: [ ^ next mapAndTrace: anObject ].
		
	clusterByObject 
		at: anObject 
		ifPresent: [: cluster |
			(self 
				clusterInstanceOf: cluster class
				keyInBucket: cluster class name 
				factory: [ cluster ])
				add: anObject traceWith: analysis
			] 
		ifAbsent: [ ^ next mapAndTrace: anObject ]
		
	! !

!MARFuelFullGlobalMapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/12/2012 20:49'!
reinitializeGlobalClusters
"All clusters should be reinitialized because they contain status of the last serialization such as the instVar 'objects' or 'theClass'. Moreoever, in the instVar 'clusterByObject'  we have already objects associated with instances of thee clusters. If we create new clusters, we will have different instances of the same cluster. In thise case, we want to use the same cluster instance, hence we reinitialize them'  '"
	instanceSideCluster initializeAnalyzing.
	classSideCluster initializeAnalyzing.
	globalsCluster initializeAnalyzing.
	globalAssociationCluster initializeAnalyzing.
	"Most #initialize do the normal initialize of a cluster, which empties 'objects'. However, for the classPool cluster, if we send #initialize we will also be cleaning what we want to cache 'classOwnerByAssociation'. So we send a specific message #reinitialize that do not clean that.  " 
	classVariablesCluster reInitialize.
	! !

!MARFuelFullGlobalMapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/20/2011 10:44'!
removeClass: aClass

	aClass classPool associationsDo: [ :aBinding | 
			clusterByObject removeKey: aBinding ifAbsent: [].
			classVariablesCluster classOwnerByAssociation removeKey: aBinding ifAbsent: []  ].
! !

!MARFuelFullGlobalMapper methodsFor: 'reseting' stamp: 'MarianoMartinezPeck 1/4/2012 17:29'!
resetForInternalObjects: aCollection

	internals := aCollection asOrderedCollection.
	self reinitializeGlobalClusters.
	"The new internal objects can already be in the 'clusterByObject', so we need to remove them from such dictionary.'. We reuse the same method #classRemoved: "
	aCollection do: [:each | self classRemoved: each ].! !

!MARFuelFullGlobalMapper methodsFor: 'reseting' stamp: 'MarianoMartinezPeck 1/3/2012 14:46'!
resetForSameInternalObjects

	self reinitializeGlobalClusters.
! !

FLMapper subclass: #MARFuelProxyMapper
	instanceVariableNames: 'mareaProxyCluster'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Serializers'!

!MARFuelProxyMapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/12/2012 12:28'!
initialize

	mareaProxyCluster := MARFuelProxyCluster newAnalyzing.
! !

!MARFuelProxyMapper methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/1/2012 20:50'!
mapAndTrace: anObject

	anObject mareaIsProxy
		ifTrue: [ self mapAndTraceByClusterName: anObject to: MARFuelProxyCluster ]
		ifFalse: [ next mapAndTrace: anObject ]
! !

!SmallInteger methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 10/4/2011 15:40'!
mareaIdentityHash

	^self hashMultiply! !

!FLFullGeneralMapper methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 1/13/2012 10:16'!
resetForInternalObjects: aCollection
	"All clusters should be reinitialized because they contain status of the last serialization such as the instVar 'objects' or 'theClass'. Most clusters are stored in the clustrerization, and we create one of them for each serialization, so those clusters are not a problem. The only ones we need to re-initialize are those which are stored in this mapper '"
	wellKnownObjectCluster := nil.
	globalInstanceSideCluster := nil.! !

!FLFullGeneralMapper methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 1/13/2012 10:11'!
resetForSameInternalObjects
	"All clusters should be reinitialized because they contain status of the last serialization such as the instVar 'objects' or 'theClass'. Most clusters are stored in the clustrerization, and we create one of them for each serialization, so those clusters are not a problem. The only ones we need to re-initialize are those which are stored in this mapper '"
	wellKnownObjectCluster := nil.
	globalInstanceSideCluster := nil.! !

!CompiledMethod class methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 12/1/2011 12:52'!
receiver: aReceirver withArgs: argArray executeMethod: compiledMethod
	"Execute compiledMethod against the receiver and args in argArray"

	<primitive: 188>
	self primitiveFailed! !

!CompiledMethod methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 1/4/2012 16:00'!
mareaIsInstalled
	self methodClass ifNotNil:
		[:class|
		self selector ifNotNil:
			[:selector|
			"If the class of the CompiledMethod is a proxy, it means that the CM was not installed, otherwise I would have been proxified also, since when a class is proxified, their CM are proxified as well. "
			class mareaIsProxy ifTrue: [^ false]. 
			^self == (class methodDict at: selector ifAbsent: [])]].
	^false
! !

!CompiledMethod methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 11/17/2010 21:58'!
mareaPrintString 
	^ self methodClass asString, '>>', self selector.! !

!SpaceTally methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 1/13/2012 16:52'!
printCSVDiffSpaceAnalysis
	"SpaceTally new printCSVDiffSpaceAnalysis"

	"sd-This method should be rewrote to be more coherent within the rest of the class 
	ie using preAllocate and spaceForInstanceOf:"

	"If threshold > 0, then only those classes with more than that number
	of instances will be shown, and they will be sorted by total instance 
	If threshold = 0, then all classes will appear, sorted by name."

	| totalCodeSpace totalInstCount totalInstSpace n totalPercent aStream threshold newTotalCodeSpace newTotalInstCount newTotalInstSpace newTotalPercent newPercent |
	
	aStream := (FileStream forceNewFileNamed: 'STspaceMarea.csv').
	threshold := 1.
	Smalltalk garbageCollect.
	totalCodeSpace := totalInstCount := totalInstSpace := n := 0.
	newTotalCodeSpace := newTotalInstCount := newTotalInstSpace := 0.
	results := OrderedCollection new: Smalltalk classNames size.
	newResults := OrderedCollection new: Smalltalk classNames size.
	
	'Taking statistics...'
		displayProgressAt: Sensor cursorPoint
		from: 0 to: Smalltalk classNames size
		during: [:bar |
		(Smalltalk globals allClasses) do:
			[:cl | | codeSpace instCount instSpace eltSize | 
			cl mareaIsProxy ifFalse: [	
				codeSpace := cl spaceUsed.
				bar value: (n := n+1).
				Smalltalk garbageCollectMost.
				instCount := cl instanceCount.
				instSpace := cl instancesSizeInMemory.
				totalCodeSpace := totalCodeSpace + codeSpace.
				totalInstCount := totalInstCount + instCount.
				totalInstSpace := totalInstSpace + instSpace.
				results add: (SpaceTallyItem analyzedClassName: cl name codeSize: codeSpace instanceCount:  instCount spaceForInstances: instSpace).]]].
	
	MARClutterCollector new testExampleSwapOutClassesForLotsOfPackages.

	'Taking statistics...'
		displayProgressAt: Sensor cursorPoint
		from: 0 to: Smalltalk classNames size
		during: [:bar |
		(Smalltalk globals allClasses) do:
			[:cl | | codeSpace instCount instSpace eltSize | 
			cl mareaIsProxy ifFalse: [	
				codeSpace := cl spaceUsed.
				bar value: (n := n+1).
				Smalltalk garbageCollectMost.
				instCount := cl instanceCount.
				instSpace := cl instancesSizeInMemory.
				newTotalCodeSpace := totalCodeSpace + codeSpace.
				newTotalInstCount := totalInstCount + instCount.
				newTotalInstSpace := totalInstSpace + instSpace.
				newResults add: (SpaceTallyItem analyzedClassName: cl name codeSize: codeSpace instanceCount:  instCount spaceForInstances: instSpace).]]].

	
	totalPercent := 0.0.
	newTotalPercent := 0.0.
	
	aStream
		nextPutAll: 'Class,' ;
		nextPutAll: 'Num instances before,';
		nextPutAll: 'Num instances after,';
		nextPutAll: 'Num instances difference,';
		nextPutAll: 'Inst space before,';
		nextPutAll: 'Inst space after,';
		nextPutAll: 'Inst space difference,';
		nextPutAll: 'Percent before,' ; 
		nextPutAll: 'Percent after,' ;
		nextPutAll: 'Inst space difference'; cr. 
		
	threshold > 0 ifTrue: [
		"If inst count threshold > 0, then sort by space"
		results := (results select: [:s | s instanceCount >= threshold or: [s spaceForInstances > (totalInstSpace // 500)]])
			asSortedCollection: [:s :s2 | s spaceForInstances > s2 spaceForInstances]].
		
	results := results reject: [:each | (each spaceForInstances*100.0/totalInstSpace  roundTo: 0.1) = 0.0].

	results do: [:s | | percent newItem |
		newItem := newResults detect: [:each | each analyzedClassName = s analyzedClassName ] ifNone: [nil].
		newItem ifNotNil: [
			aStream
				nextPutAll: (s analyzedClassName, ',');
				nextPutAll: (s instanceCount printString , ',' );
				nextPutAll: (newItem instanceCount printString , ',' );
				nextPutAll: ((s instanceCount - newItem instanceCount) printString , ',' );
				nextPutAll: (s spaceForInstances printString , ',' );
				nextPutAll: (newItem spaceForInstances printString , ',' );
				nextPutAll: ((s spaceForInstances - newItem spaceForInstances) printString , ',' ).
				
				
			percent := s spaceForInstances*100.0/totalInstSpace roundTo: 0.1.
			totalPercent := totalPercent + percent.
			aStream nextPutAll: ((percent printShowingDecimalPlaces: 2) , ',' ).
			
			newPercent := newItem spaceForInstances*100.0/newTotalInstSpace roundTo: 0.1.
			newTotalPercent := newTotalPercent + newPercent.
			aStream nextPutAll: ((newPercent printShowingDecimalPlaces: 2) , ',').
			
			aStream nextPutAll: (((percent - newPercent) printShowingDecimalPlaces: 2) ).

			aStream cr]
	].
	
"	
	aStream
		cr; nextPutAll: ('Total,'  );
		nextPutAll: (totalCodeSpace printString , ',' );
		nextPutAll: (totalInstCount printString , ',' );
		nextPutAll: (totalInstSpace printString , ',' );
		nextPutAll: ((totalPercent roundTo: 0.1) printString ). 
	
"! !

FLAnalyzer subclass: #MARFuelAnalyzer
	instanceVariableNames: 'mappers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Serializers'!

!MARFuelAnalyzer methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/4/2012 17:23'!
fullGlobalMappers

	^Array with: (MARFuelFullGlobalMapper newWithInternals: internalClasses)! !

!MARFuelAnalyzer methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/12/2012 17:57'!
listOfMappers
	| list |
	list := OrderedCollection new.
	list add: MARFuelProxyMapper new.
	list addAll: self pluggableSubstitutionMappers.
	list addAll: self globalMappers.
	list add: self generalMapper.
	^ list reduceRight: [:left :right | left next: right ]; yourself! !

!MARFuelAnalyzer methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/12/2012 12:41'!
mappers
	mappers isNil ifTrue: [ mappers :=  self listOfMappers].
	^mappers! !

!MARFuelAnalyzer methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/19/2011 10:51'!
reset
	self resetWithInternalObjects: OrderedCollection new.! !

!MARFuelAnalyzer methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/3/2012 14:36'!
resetForSameInternalObjects
	pluggableSubstitutions := OrderedCollection new.
	self mappers do: [:each | each resetForSameInternalObjects ].
! !

!MARFuelAnalyzer methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/12/2012 20:33'!
resetWithInternalObjects: aCollection
	internalClasses := aCollection asOrderedCollection.
	pluggableSubstitutions := OrderedCollection new.
	self mappers do: [:each | each resetForInternalObjects: aCollection ].
! !

!FLMaterializer methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 1/12/2012 18:01'!
setMareaMaterialization

	materializationFactory := [:aDecoder | 
		(FLMaterialization 
			with: aDecoder) 
			runWithOutAterMaterializationStep; 
			yourself ]
	! !

!Behavior methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 3/14/2011 22:54'!
hasAllMethodsAsProxies
	^ self allMethods allSatisfy: [:aMethod | aMethod mareaIsProxy  ].
	! !

!Behavior methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 12/8/2011 21:32'!
mareaFindClassWithNilMethodDictInHierarchy
	methodDict isNil 
		ifTrue: [ ^ self ]
		ifFalse: [ ^ CompiledMethod receiver: superclass withArgs: #() executeMethod: (Behavior >> #mareaFindClassWithNilMethodDictInHierarchy) ]! !

!Behavior methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 3/13/2011 22:50'!
methodDict
	methodDict == nil ifTrue: ["self manageMDFault" ^ self emptyMethodDictionary  ].
	^ methodDict! !

!MethodReference methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 11/28/2010 20:21'!
mareaPrintString
	^ self actualClass name, ' >> #', methodSymbol! !

!ProtoObject methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 10/20/2010 11:33'!
class
	"Primitive. Answer the object which is the receiver's class. Essential. See 
	Object documentation whatIsAPrimitive."

	<primitive: 111>
	self primitiveFailed! !

!ProtoObject methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 11/17/2010 19:53'!
mareaClass
	"Primitive. Answer the object which is the receiver's class. Essential. See 
	Object documentation whatIsAPrimitive."

	<primitive: 111>
	self primitiveFailed! !

!ProtoObject methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 10/4/2011 15:17'!
mareaIdentityHash
	"Answer a SmallInteger whose value is related to the receiver's identity.
	This method must not be overridden, except by SmallInteger.
	
	Do not override."

	^ self basicIdentityHash bitShift: 18! !

!ProtoObject methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 12/17/2011 01:39'!
mareaLog: anObject
	MARLogger logger log: anObject.! !

!SystemDictionary methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 2/1/2012 22:24'!
mareaAllClassesAndTraitsWithoutProxiesDo: aBlock
	"Evaluate the argument, aBlock, for each class and trait in the system."
	
	^self classAndTraitNames do: [:each | 
		(Smalltalk at: each) mareaIsProxy ifFalse:
		[aBlock value: (self at: each)] ]
	
	
! !

Error subclass: #MARCannotProxifyCompactClasses
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Proxies'!

Error subclass: #MARClassHasProxifiedSubclass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Errors'!

Error subclass: #MARGraphIDBiggerThanMax
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Proxies'!

Error subclass: #MARObjectAlreadyProxified
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Errors'!

Error subclass: #MARObjectIsNotProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Swapping'!

Error subclass: #MARPositionBiggerThanMax
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Proxies'!

Error subclass: #MARProxyIsNotInstalled
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Proxies'!

!FLSerialization methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 1/6/2012 20:24'!
objectsIndexes
	^ encoder objectsIndexes ! !

FLSerialization subclass: #MARFuelSerialization
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Serializers'!

!MARFuelSerialization methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/3/2012 15:12'!
analysisStep
	| proxyCluster shouldContinue |	
	"It can happen that while analyzing a graph to serialize, a proxy inside such graph receives a message. Such proxy could have been already analyzed and put in the FLProxyCluster. The problem is that then, at serialization time, the proxy has becomed the original object (becasue it has received a message) and hence, the serialization of FLProxyCluster will fail trying to send #mareaProxyID. 
	To solve this, we make sure that after the analysis phase, no analyzed proxy has been becomed the original object. And if there were proxies who has been becomed, then we execute the analysis phase again and again until all proxies in the cluster are the same as the beginning.
	For more details see #testProxyUninstalledWhileSwappingOut"
"	super analysisStep.		"
	[ super analysisStep.
	proxyCluster := clusters detect: [:each | each class = MARFuelProxyCluster ] ifNone: [^ self ].
		(proxyCluster objects anySatisfy: [:each | each mareaIsProxy not ])
			ifTrue: [ analyzer resetForSameInternalObjects.
				       shouldContinue := true.  ]
			ifFalse: [ shouldContinue := false ].
	] doWhileTrue: [ shouldContinue  ]! !

!SmalltalkImage methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 12/9/2011 17:43'!
mareaAllClassesAndTraitsWithoutProxiesDo: aBlock
	^globals mareaAllClassesAndTraitsWithoutProxiesDo: aBlock! !

TestCase subclass: #MARClutterCollector
	instanceVariableNames: 'initialProxiesCount initialCMCount initialMDCount initialMetaclassesCount finalProxiesCount finalCMCount finalMDCount finalMetaclassesCount diffProxiesCount diffCMCount diffMDCount diffMetaclassesCount classesNotToSwap initialTraitCompositionCount initialClassOrganizerCount initialSymbolCount initialByteStringCount initialArrayCount initialAssociationCount initialOrderedCollectionCount finalTraitCompositionCount finalClassOrganizerCount finalSymbolCount finalByteStringCount finalArrayCount finalAssociationCount finalOrderedCollectionCount diffTraitCompositionCount diffClassOrganizerCount diffSymbolCount diffByteStringCount diffArrayCount diffAssociationCount diffOrderedCollectionCount initialObjectProxiesCount finalObjectProxiesCount initialForwardingPointers finalForwardingPointers'
	classVariableNames: 'Logger'
	poolDictionaries: ''
	category: 'Marea-Swapping'!

!MARClutterCollector class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/13/2011 10:05'!
proxyClass
	^ ProxyClass ! !

!MARClutterCollector class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/13/2011 10:05'!
proxyClass: aProxyClass
	ProxyClass := aProxyClass.! !

!MARClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/1/2012 22:23'!
canClassBeSwapped: aClass
	
	(self classesNotToSwap includes: aClass) ifTrue: [^ false].
	^ true! !

!MARClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/15/2011 15:12'!
classesAllPackagesExcludingSubstrings: excludingStrings 

	| classesToSwap |
	classesToSwap := IdentitySet new.
	(PackageInfo allPackages select: [:each| 
		(excludingStrings noneSatisfy:  [:aString  | (each packageName includesSubString: aString)])
		] ) 
	do: [:aPackage |
		classesToSwap addAll: (aPackage classes select: [:each | self canClassBeSwapped: each ]  )
		].
	^ classesToSwap.! !

!MARClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/13/2011 12:18'!
classesNotToSwap
	classesNotToSwap isNil ifTrue: [classesNotToSwap :=  self listOfClassesNotToSwap ].
	^ classesNotToSwap! !

!MARClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/13/2011 12:50'!
classesToSwapOutOfPackagesIncludingSubstrings: includingStrings excludingSubstrings: excludingStrings 

	| classesToSwap |
	classesToSwap := IdentitySet new.
	(PackageInfo allPackages select: [:each| 
		(includingStrings anySatisfy:  [:aString  | (each packageName includesSubString: aString)]) and: 
		[(excludingStrings noneSatisfy:  [:aString  | (each packageName includesSubString: aString)])]   
		] ) 
	do: [:aPackage |
		classesToSwap addAll: (aPackage classes select: [:each | self canClassBeSwapped: each ]  )
		].
	^ classesToSwap.! !

!MARClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/6/2012 15:11'!
clean
	MCMethodDefinition shutDown.
	MARObjectGraphSwapper clean.
	Symbol compactSymbolTable.
	3 timesRepeat: [Smalltalk garbageCollect].
	! !

!MARClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/10/2012 15:12'!
initializeAndClean
 
	MARObjectGraphExporter reset.
	MARObjectGraphSwapper resetAll.
	MARObjectGraphExporter proxyCreator: MARProxyCreator.
	3 timesRepeat: [Smalltalk garbageCollect].
	MARRegularObjectProxy mareaUninstallIfNeededAllInstances.
	MARClassProxy mareaUninstallIfNeededAllInstances.
	Logger := nil.
	(FileDirectory default fileNamesMatching: '*.swap*') 
		do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].
	FileDirectory default deleteFileNamed:  'MareaDebug.log'.
	FileDirectory default deleteFileNamed:  'MareaLog.txt'.
	FileDirectory default deleteFileNamed:  'Swapper.txt'.
	FileDirectory default deleteFileNamed:  'crash.dmp'.
	MARLogger createAndSetLogger.
	self clean.
! !

!MARClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/2/2012 19:07'!
listOfClassesNotToSwap

	| tooDangerousClasses coreClasses protoObjectSubclasses classesSpecialArray veryUsedClasses allClasses debuggingClasses nilSubclasses startUpOrShutDownClasses compactClasses classesTooBig |

	"This are classes that are known as too dangerous."
	tooDangerousClasses := OrderedCollection new.
	(ClassBuilder new tooDangerousClasses) 
		do: [:each | Smalltalk globals at: each 
			ifPresent: [:present | tooDangerousClasses add: (Smalltalk at: each) ] 
			ifAbsent: []].
	
	"These classes because they are too core and used by the code to swapout itseld"
	coreClasses :=  {Array. Object. ProtoObject. Class. Message. MethodDictionary. CompiledMethod}. 

	"Subclasses of ProtoObject because they do not implement some methods that Object does and that are used by the swapping stuff."
	protoObjectSubclasses := ProtoObject subclasses.
	
	"These classes cannot be swapped because they are used by the VM"
	classesSpecialArray := Smalltalk specialObjectsArray select: [ :each | each isBehavior ].
	
	"These classes cannot be swapped because they are use) even before swappping out. EventManager cannot be swapped because it is used by the GC and if we use the GC during the swapping in, we end up in a loop. Project cannot be swapped beause it crash the VM. ."
	veryUsedClasses := { Cursor. CursorWithMask. EncodedCharSet. Project. EventManager.}.
	
	"Classes that are usually needed to debug and they help us to analyze problems"
	debuggingClasses := { DEVToolSet. }.
	
	"nil subclasses cannot be swapped out because since they don't subclass ProtoObject they may not even implement doesNotUnderstand:.
	For example, if we swap a CompiledMethod of PseudoContext, and then we try to load it back, the VM will crash with the error Recursive not understood error encountered. '"
	nilSubclasses := nil subclasses.
	
	"Classes that do something in startUp are difficult to swap because the VM may crash."
	startUpOrShutDownClasses := OrderedCollection new.
	startUpOrShutDownClasses addAll: ((Smalltalk class classVarNamed: 'StartUpList') collect: [:each | Smalltalk at: each]).
	startUpOrShutDownClasses addAll: ((Smalltalk class classVarNamed: 'ShutDownList') collect: [:each | Smalltalk at: each]).
	startUpOrShutDownClasses := startUpOrShutDownClasses asArray.
	
	"Compact classes cannot be swapped because I may have problems with its instances and their object header"
	compactClasses := Smalltalk compactClassesArray.
	
	"These are classes that when swapping them out they are terrible big, hence we do not focus on them yet. For example MCCacheRepository, its instance class variable 'default' is HUGE"
	classesTooBig := {MCCacheRepository. SHTextStyler. OCompletionTable.}.
	
	allClasses := coreClasses, protoObjectSubclasses, classesSpecialArray, veryUsedClasses, tooDangerousClasses, debuggingClasses, nilSubclasses, startUpOrShutDownClasses, compactClasses, classesTooBig.
	
	^ allClasses asIdentitySet ! !

!MARClutterCollector methodsFor: 'logging' stamp: 'MarianoMartinezPeck 12/13/2011 10:19'!
log: aString
	self logger log: aString ! !

!MARClutterCollector methodsFor: 'logging' stamp: 'MarianoMartinezPeck 12/14/2011 23:27'!
logDifferences

	diffProxiesCount :=  initialProxiesCount - finalProxiesCount.
	diffCMCount := initialCMCount - finalCMCount.
	diffMDCount := initialMDCount - finalMDCount.
	diffMetaclassesCount := initialMetaclassesCount - finalMetaclassesCount.
	diffTraitCompositionCount :=  initialTraitCompositionCount - finalTraitCompositionCount.
	diffClassOrganizerCount := initialClassOrganizerCount - finalClassOrganizerCount.
	diffSymbolCount := initialSymbolCount - finalSymbolCount.
	diffByteStringCount := initialByteStringCount - finalByteStringCount.
	diffArrayCount := initialArrayCount - finalArrayCount.
	diffAssociationCount := initialAssociationCount - finalAssociationCount.
	diffOrderedCollectionCount := initialOrderedCollectionCount - finalOrderedCollectionCount.


	self log: '------------------------------------------------------------------'.
	self log: 'Results (difference between initial and final state) of the swapping: '.
	self log: 'CompiledMethods: ', diffCMCount asString.
	self log: 'MethodDictionaries: ', diffMDCount asString.
	self log: 'Metaclasses: ', diffMetaclassesCount asString.
	self log: 'TraitCompositions: ', diffTraitCompositionCount asString.
	self log: 'ClassOrganizer: ', diffClassOrganizerCount asString.
	self log: 'Symbols ', diffSymbolCount asString.
	self log: 'ByteStrings ', diffByteStringCount asString.
	self log: 'Arrays: ', diffArrayCount asString.	
	self log: 'Associations: ', diffAssociationCount asString.	
	self log: 'OrderedCollection:  ', diffOrderedCollectionCount asString.	
	
	
	
	
	! !

!MARClutterCollector methodsFor: 'logging' stamp: 'MarianoMartinezPeck 1/9/2012 11:38'!
logFinalState

	finalProxiesCount := MARClassProxy mareaAllInstalledProxiesCount.
	finalObjectProxiesCount := MARRegularObjectProxy mareaAllInstalledProxiesCount.
	finalForwardingPointers := MARForwardingPointer instanceCount.
	finalCMCount := CompiledMethod instanceCount.
	finalMDCount := MethodDictionary instanceCount.
	finalMetaclassesCount := Metaclass instanceCount.
	finalTraitCompositionCount := TraitComposition instanceCount.
	finalClassOrganizerCount := ClassOrganizer instanceCount.
	finalSymbolCount := Symbol allSymbols size.
	finalByteStringCount := ByteString instanceCount.
	finalArrayCount := Array instanceCount.
	finalAssociationCount := Association instanceCount.
	finalOrderedCollectionCount := OrderedCollection instanceCount.
	
	
	self log: '------------------------------------------------------------------'.
	self log: 'Information after swapping: '.
	"The amount of proxies can be less than the amount of swapped out classes, since some proxies, like some of the metaclasses, could have been garbage collected."
	self log: 'Class Proxies: ', finalProxiesCount asString.
	self log: 'Regular objects proxies: ', finalObjectProxiesCount asString.
	self log: 'Forwarding pointers: ', finalForwardingPointers asString.
	self log: 'MethodDictionaries: ', finalMDCount asString.
	self log: 'Metaclasses: ', finalMetaclassesCount asString.
	self log: 'TraitCompositions: ', finalTraitCompositionCount asString.
	self log: 'ClassOrganizer: ', finalClassOrganizerCount asString.
	self log: 'Symbols ', finalSymbolCount asString.
	self log: 'ByteStrings ', finalByteStringCount asString.
	self log: 'Arrays: ', finalArrayCount asString.	
	self log: 'Associations: ', finalAssociationCount asString.	
	self log: 'OrderedCollection:  ', finalOrderedCollectionCount asString.	
	! !

!MARClutterCollector methodsFor: 'logging' stamp: 'MarianoMartinezPeck 1/6/2012 14:30'!
logGlobalState

	self log: '------------------------------------------------------------------'.
	self log: 'Information after swapping: '.
	self log: 'Global Graph Table size: ', MARObjectGraphSwapper globalGraphTable size asString.	
	self log: 'Global Shared Proxies Table size: ', MARObjectGraphSwapper globalSharedProxiesTable size asString.	
	! !

!MARClutterCollector methodsFor: 'logging' stamp: 'MarianoMartinezPeck 1/9/2012 11:38'!
logInitialState
		
	initialProxiesCount := MARClassProxy mareaAllInstalledProxiesCount.
	initialObjectProxiesCount := MARRegularObjectProxy mareaAllInstalledProxiesCount.
	initialForwardingPointers := MARForwardingPointer instanceCount.
	initialCMCount := CompiledMethod instanceCount.
	initialMDCount := MethodDictionary instanceCount.
	initialMetaclassesCount := Metaclass instanceCount.
	initialTraitCompositionCount := TraitComposition instanceCount.
	initialClassOrganizerCount := ClassOrganizer instanceCount.
	initialSymbolCount := Symbol allSymbols size.
	initialByteStringCount := ByteString instanceCount.
	initialArrayCount := Array instanceCount.
	initialAssociationCount := Association instanceCount.
	initialOrderedCollectionCount := OrderedCollection instanceCount.
	
	
	self log: '------------------------------------------------------------------'.
	self log: 'Information before swapping: '.
	self log: 'Class Proxies: ', initialProxiesCount asString.
	self log: 'Regular objects proxies: ', initialObjectProxiesCount asString.
	self log: 'Forwarding pointers: ', initialForwardingPointers asString.
	self log: 'CompiledMethods: ', initialCMCount asString.
	self log: 'MethodDictionaries: ', initialMDCount asString.
	self log: 'Metaclasses: ', initialMetaclassesCount asString.
	self log: 'TraitCompositions: ', initialTraitCompositionCount asString.
	self log: 'ClassOrganizer: ', initialClassOrganizerCount asString.
	self log: 'Symbols ', initialSymbolCount asString.
	self log: 'ByteStrings ', initialByteStringCount asString.
	self log: 'Arrays: ', initialArrayCount asString.	
	self log: 'Associations: ', initialAssociationCount asString.	
	self log: 'OrderedCollection:  ', initialOrderedCollectionCount asString.	
	! !

!MARClutterCollector methodsFor: 'logging' stamp: 'MarianoMartinezPeck 12/15/2011 17:01'!
logObjectsToSwapInfo: objectsToSwap
	| methods |
	self log: '------------------------------------------------------------------'.
	self log: 'Information of the classes to swap out: '.
	self log: 'Classes: ',  (objectsToSwap size) asString.
	self log: 'Metaclasses: ',  (objectsToSwap size) asString.
	methods := objectsToSwap  inject: 0  into: [ :total :each | total +  each methodDict size + each class methodDict size].
	self log: 'CompiledMethods: ',  methods asString.
	! !

!MARClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/13/2011 10:19'!
logger	
	Logger isNil ifTrue: [
		Logger := FixesFileNameLoggerStrategy named: 'Swapper.txt'.
		Logger startLogging].
	^ Logger! !

!MARClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/2/2012 10:01'!
setUp
	self initializeAndClean.
	self logInitialState.! !

!MARClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/13/2012 10:27'!
swapOutClass: aClass
	[MARObjectGraphExporter new swapOutClassWithInstances: aClass]
 		on: MARObjectAlreadyProxified, MARClassHasProxifiedSubclass, MARPositionBiggerThanMax, MARGraphIDBiggerThanMax, FLObjectNotFound 
		do: [ :err | self mareaLog: err messageText ]! !

!MARClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/2/2012 11:35'!
swapOutGraph: anObject
	[MARObjectGraphExporter new swapOutGraph: anObject]
 		on: MARObjectAlreadyProxified, MARClassHasProxifiedSubclass, MARPositionBiggerThanMax, MARGraphIDBiggerThanMax, FLObjectNotFound 
		do: [ :err | self mareaLog: err messageText ]! !

!MARClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/2/2012 14:50'!
testExampleSwapDevelopmentTools
	"self testExampleSwapOutThemes"
	| objectsToSwap timeToInstall classesToSwap |

	objectsToSwap := OrderedCollection new.
	classesToSwap := { TestRunnerBrowser. SystemBrowser. FlatMessageListBrowser. HierarchyBrowser. ClassListBrowser. ChangedMessageSet. MessageNames. ProtocolBrowser. RecentMessageSet. ChangeList. VersionsBrowser. ChangeSorter. ChangeSetBrowser. DualChangeSorter. TimeProfiler. TimeProfileBrowser. PointerExplorer. ViewHierarchyExplorer. ObjectExplorerWrapper. ViewHierarchyExplorer. FileContentsBrowser. FileList. Inspector. ProcessBrowser. Debugger. PreDebugWindow. TimeProfileBrowser. TimeProfiler. Finder. FinderUI. FinderNode. }.
			
	timeToInstall := MessageTally time: [
		objectsToSwap do: [:each |  self swapOutGraph: each].
		classesToSwap do: [:each |  self swapOutClass: each].

	].

	
	self log: 'Time to swap out: ', timeToInstall asString, ' miliseconds'.
	
	objectsToSwap := nil.
	self clean.
	self logGlobalState.
	self logFinalState.
	self logDifferences.! !

!MARClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/2/2012 17:01'!
testExampleSwapOutClassesForLotsOfPackages
	"self exampleSwapOutTestMethodsForOnePackage"
	| objectsToSwap timeToInstall timeToUninstall kernelPackages |
	
	kernelPackages := # ('Marea' 'Fuel' 'Kernel' 'Graphics' 'Exceptions' 'Settings' 'System' 'Traits' 'Balloon' 'Tools-Base' 'Morphic' 'Compiler' 'Collections' 'Files' 'SimpleLogger' 'UIManager' 'Polymorph' 'Multilingual' ).
	objectsToSwap := self classesAllPackagesExcludingSubstrings: kernelPackages.

	self logObjectsToSwapInfo: objectsToSwap.
		
	timeToInstall := MessageTally time: [
		objectsToSwap do: [:each |  self swapOutClass: each].
	].
	self log: 'Time to swap out: ', timeToInstall asString, ' miliseconds'.
	
	
	objectsToSwap := nil.
	self clean.
	self logGlobalState.
	self logFinalState.
	self logDifferences.
	! !

!MARClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/2/2012 17:51'!
testExampleSwapOutClassesForMaxPossiblePackages
	"self exampleSwapOutTestMethodsForOnePackage"
	| objectsToSwap timeToInstall timeToUninstall kernelPackages |
	
	kernelPackages := # ('Marea' 'Fuel' 'SimpleLogger' 'Kernel' 'Graphics' 'Exceptions' 'Settings' 'Traits' "'Balloon'" "'Morphic'" 'Compiler' 'Collections' 'Files' 'UIManager' 'Polymorph' 'Multilingual' ).
	objectsToSwap := self classesAllPackagesExcludingSubstrings: kernelPackages.
	classesNotToSwap := #('System-Finalization' 'System-Platforms' 'System-Support' 'System-Text' 'Tools-Base' "'Balloon-Engine'" 'Morphic-Basic' 'Morphic-Events' 'Morphic-Kernel'  'Morphic-Layouts' 'Morphic-New Text Support'  'Morphic-Support' 'Morphic-Text Support' 'Morphic-Windows') inject: IdentitySet new into: [:total :each | total addAll: (PackageInfo named: each) classes. total].
	objectsToSwap := objectsToSwap reject: [:each | classesNotToSwap identityIncludes: each]. 
	self logObjectsToSwapInfo: objectsToSwap.
		
	timeToInstall := MessageTally time: [
		objectsToSwap do: [:each |  self swapOutClass: each].
	].
	self log: 'Time to swap out: ', timeToInstall asString, ' miliseconds'.
	
	
	objectsToSwap := nil.
	self clean.
	self logGlobalState.
	self logFinalState.
	self logDifferences.
	! !

!MARClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/2/2012 22:19'!
testExampleSwapOutClassesForSomePackages
	"self exampleSwapOutTestMethodsForOnePackage"
	| objectsToSwap timeToInstall timeToUninstall |

	objectsToSwap := self classesToSwapOutOfPackagesIncludingSubstrings: #( 'AST' 'Autotest' 'AutomaticMethodCategorizer' 'Bogus' 'CodeStats'  'Gofer' 'Metacello' 'FreeType' 'HelpSystem' 'ProfStef' 'ScriptManager' 'Zinc' 'Sound' 'Tests' 'ConfigurationOf' 'ImageForDevelopers' 'LED' 'MemoryMonitor' 'SUnit' 'TrueType' 'Monticello'  "'Network'" 'Refactoring' 'Regex' 'ToolBuilder' 'Compression' 'Shout' )
	excludingSubstrings: #('Marea').

	self logObjectsToSwapInfo: objectsToSwap.
		
	timeToInstall := MessageTally time: [
		objectsToSwap do: [:each |  self swapOutClass: each].
	].
	self log: 'Time to swap out: ', timeToInstall asString, ' miliseconds'.
	
	
	objectsToSwap := nil.
	self clean.
	self logGlobalState.
	self logFinalState.
	self logDifferences.
	! !

!MARClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/2/2012 12:41'!
testExampleSwapOutFonts
	"self testExampleSwapOutThemes"
	| objectsToSwap timeToInstall classesToSwap |

	objectsToSwap := OrderedCollection new.
	objectsToSwap add: (TextStyle named: #Accuny).
	classesToSwap := {TTCFont. StrikeFontSet. TTCFontSet. TTFontDescription. TTGlyph. TTKernPair. StrikeFontFixer. XTableForUnicodeFont. XTableForFixedFont. TTFontReader. TTPoint. TTFontTableDirEntry. TTContourConstruction. FontSet. BDFFontReader. "StrikeFont." "FixedFaceFont"}.
			
	timeToInstall := MessageTally time: [
		objectsToSwap do: [:each |  self swapOutGraph: each].
		classesToSwap do: [:each |  self swapOutClass: each].

	].

	
	self log: 'Time to swap out: ', timeToInstall asString, ' miliseconds'.
	
	objectsToSwap := nil.
	self clean.
	self logGlobalState.
	self logFinalState.
	self logDifferences.! !

!MARClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/2/2012 12:56'!
testExampleSwapOutLocales
	"self testExampleSwapOutLocales"
	| objectsToSwap timeToInstall classesToSwap |

	objectsToSwap := (Locale allInstances reject: [:each | each == Locale current]).
	classesToSwap := (LanguageEnvironment allSubclasses reject: [:each | each == LanguageEnvironment currentPlatform class]) asOrderedCollection.
	classesToSwap addAll: (TextConverter allSubclasses reject: [:each | (each == TextConverter default class) or: [each == LanguageEnvironment  defaultSystemConverter class ]]).
			
	timeToInstall := MessageTally time: [
		objectsToSwap do: [:each |  self swapOutGraph: each].
		classesToSwap do: [:each |  self swapOutClass: each].
	].

	
	self log: 'Time to swap out: ', timeToInstall asString, ' miliseconds'.
	
	objectsToSwap := nil.
	self clean.
	self logGlobalState.
	self logFinalState.
	self logDifferences.! !

!MARClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/2/2012 12:18'!
testExampleSwapOutSounds
	"self testExampleSwapOutSounds"
	| objectsToSwap timeToInstall |

	objectsToSwap := {SoundService. SoundTheme. }.
 		
	timeToInstall := MessageTally time: [
		objectsToSwap do: [:each |  self swapOutClass: each].
	].
	self log: 'Time to swap out: ', timeToInstall asString, ' miliseconds'.
	
	
	objectsToSwap := nil.
	self clean.
	self logGlobalState.
	self logFinalState.
	self logDifferences.! !

!MARClutterCollector methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/2/2012 11:10'!
testExampleSwapOutThemes
	"self testExampleSwapOutThemes"
	| objectsToSwap timeToInstall |

	objectsToSwap := {BlueUITheme. UIThemeStandardSqueak. UIThemeVistary. UIThemeW2K. GLMOrangeUITheme. VistaryThemeIcons. WateryThemeIcons.}.
 		
	timeToInstall := MessageTally time: [
		objectsToSwap do: [:each |  self swapOutClass: each].
	].
	self log: 'Time to swap out: ', timeToInstall asString, ' miliseconds'.
	
	
	objectsToSwap := nil.
	self clean.
	self logGlobalState.
	self logFinalState.
	self logDifferences.! !

!Class methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 12/20/2011 14:31'!
newProxy
	^ MARClassProxy newProxy! !

!FLMaterialization methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 1/5/2012 10:37'!
internalBehaviors
	| internalBehaviors |
	internalBehaviors := OrderedCollection new.
	(clusters select: [:each | each class inheritsFrom: FLBehaviorCluster ])
		do: [:each | internalBehaviors addAll: each objects].
	^ internalBehaviors ! !

!FLMaterialization methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 12/14/2011 11:18'!
runWithOutAterMaterializationStep

	self headerStep.
	self instancesStep.
	self referencesStep.
	self trailerStep.
! !

IdentitySet subclass: #MARProxiesIdentitySet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Collections'!

!MARProxiesIdentitySet methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/4/2011 15:23'!
asProxiesIdentitySet
	^self! !

!MARProxiesIdentitySet methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/4/2011 15:23'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."

	| index start hash |
	hash := anObject mareaIdentityHash.
	index := start := hash \\ array size + 1.
	[ 
		| element |
		((element := array at: index) == nil or: [ element enclosedSetElement == anObject ])
			ifTrue: [ ^index ].
		(index := index \\ array size + 1) = start ] whileFalse.
	self errorNoFreeSpace! !

!MARProxiesIdentitySet methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/4/2011 15:24'!
scanForEmptySlotFor: aKey
	"Scan the key array for the first slot containing an empty slot (indicated by a nil). Answer the index of that slot. This method will be overridden in various subclasses that have different interpretations for matching elements."
	
	| index start |
	index := start := aKey mareaIdentityHash \\ array size + 1.
	[ 
		(array at: index) ifNil: [ ^index ].
		(index := index \\ array size + 1) = start ] whileFalse.
	self errorNoFreeSpace! !

!Metaclass methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 2/1/2012 15:54'!
newProxy
	"Metaclasses can use a regular proxy and not one similary to the ClassProxy just because since we always swap also its unique instance (a class) there won't be any instance of this class (because its unique instance is proxified also), hence we do not need  proxy like ClassProxy."
	^ MARMetaclassProxy newProxy! !

!FLGlobalClassPoolAssociationCluster methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 1/12/2012 12:30'!
reInitialize
	objects := self newAnalyzingCollection.! !

IdentityDictionary subclass: #MARProxiesIdentityDictionary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Collections'!

!MARProxiesIdentityDictionary methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/4/2011 14:59'!
scanFor: anObject
	"Scan the key array for the first slot containing either a nil (indicating an empty slot) or an element that matches anObject. Answer the index of that slot or zero if no slot is found. This method will be overridden in various subclasses that have different interpretations for matching elements."
	| finish start element |
	finish := array size.
	start := (anObject mareaIdentityHash \\ finish) + 1.

	"Search from (hash mod size) to the end."
	start to: finish do:
		[:index | ((element := array at: index) == nil or: [element key == anObject])
			ifTrue: [^ index ]].

	"Search from 1 to where we started."
	1 to: start-1 do:
		[:index | ((element := array at: index) == nil or: [element key == anObject])
			ifTrue: [^ index ]].

	^ 0  "No match AND no empty slot"! !

!MARProxiesIdentityDictionary methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/4/2011 14:59'!
scanForEmptySlotFor: aKey
	"Scan the key array for the first slot containing an empty slot (indicated by a nil). Answer the index of that slot. This method will be overridden in various subclasses that have different interpretations for matching elements."
	
	| index start |
	index := start := aKey mareaIdentityHash \\ array size + 1.
	[ 
		(array at: index) ifNil: [ ^index ].
		(index := index \\ array size + 1) = start ] whileFalse.
	self errorNoFreeSpace! !

!WorldState methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 1/13/2012 10:49'!
fuelAccept: aVisitor

	^aVisitor visitGlobalSend: self name: #World selector: #worldState! !

Object subclass: #MARAbstractMareaSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Serializers'!

!MARAbstractMareaSerializer methodsFor: 'API' stamp: 'MarianoMartinezPeck 12/12/2011 10:54'!
materializeObjectFrom: aFileName
	self shouldBeImplemented ! !

!MARAbstractMareaSerializer methodsFor: 'API' stamp: 'MarianoMartinezPeck 1/2/2012 10:51'!
serialize: anObject to: aFileName
	self shouldBeImplemented ! !

MARAbstractMareaSerializer subclass: #MARFuelMareaSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Serializers'!

MARFuelMareaSerializer subclass: #MARFuelCachedMareaSerializer
	instanceVariableNames: ''
	classVariableNames: 'CachedAnalyzer'
	poolDictionaries: ''
	category: 'Marea-Serializers'!

!MARFuelCachedMareaSerializer class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 1/4/2012 16:59'!
cachedAnalyzer
	CachedAnalyzer isNil ifTrue: [ CachedAnalyzer := MARFuelAnalyzer newDefault useFullMappers].
	^ CachedAnalyzer 
	! !

!MARFuelCachedMareaSerializer class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/19/2011 11:26'!
cachedAnalyzer: anObject
	CachedAnalyzer := anObject! !

!MARFuelCachedMareaSerializer class methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 12/19/2011 12:14'!
classAdded: anEvent

	self cachedAnalyzer mappers do: [:each | each classAdded: anEvent item ]
! !

!MARFuelCachedMareaSerializer class methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 12/20/2011 10:42'!
classModified: anEvent
	"Even if the event was a class modified, since we use IdentityDictionary we can use the same event as #classAdded:"
	self cachedAnalyzer mappers do: [:each | each classAdded: anEvent item ]
! !

!MARFuelCachedMareaSerializer class methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 12/19/2011 12:14'!
classRemoved: anEvent

	self cachedAnalyzer mappers do: [:each | each classRemoved: anEvent item ]
! !

!MARFuelCachedMareaSerializer class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/4/2012 17:19'!
initialize
	self initializeListeners.
	CachedAnalyzer := nil.
	
	! !

!MARFuelCachedMareaSerializer class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/19/2011 16:44'!
initializeListeners

	self flag: #todo. "unregistrer? anocher better way of doing this?"

	SystemChangeNotifier uniqueInstance 
		notify: self
			ofSystemChangesOfItem: #class
			change: #Removed
			using: #classRemoved:;
		notify: self
			ofSystemChangesOfItem: #class
			change: #Added
			using: #classAdded:;
		notify: self
			ofSystemChangesOfItem: #class
			change: #Modified
			using: #classModified:.! !

!MARFuelCachedMareaSerializer class methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 12/19/2011 11:56'!
removeClassFromAnalyzer: aClass
	self mappers do: [:each | each classRemoved: aClass ]
! !

!MARFuelCachedMareaSerializer class methodsFor: 'reset' stamp: 'MarianoMartinezPeck 12/19/2011 11:25'!
resetCachedAnalyzer
	^ self cachedAnalyzer reset
	! !

!MARFuelCachedMareaSerializer class methodsFor: 'reset' stamp: 'MarianoMartinezPeck 12/19/2011 11:25'!
resetCachedAnalyzerWithInternalObjects: aCollection
	^ self cachedAnalyzer resetWithInternalObjects: aCollection
	! !

!MARFuelCachedMareaSerializer class methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 2/1/2012 23:06'!
serialize: anObject to: aStream
	^ self serialize: anObject withInternalClasses: #() to: aStream! !

!MARFuelCachedMareaSerializer class methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 2/1/2012 23:05'!
serialize: anObject withInternalClasses: aCollection to: aStream
	| serialization  serializer | 
	self resetCachedAnalyzerWithInternalObjects: aCollection.
	serializer := FLSerializer newDefault analyzer: self cachedAnalyzer.
	serializer mareaSerialization.
	serialization := serializer serialize: anObject on: aStream.
	aStream close.
	self mareaLog: 'The object ', anObject mareaBasicName, ' was written on file'.
	^ serialization! !

!MARFuelMareaSerializer class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 11/30/2011 14:22'!
newDefault
	^ self new! !

!MARFuelMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 2/2/2012 18:04'!
materializeObjectFrom: aStream
	| materialization |
	
	materialization := FLMaterializer newDefault 
	"With #setMareaMaterialization we make sure that Fuel does NOT run the #afterMaterializationStep. The object swapper will take care of doing that when he thinks it is correct. For more details see ObjectGraphSwapper >> swapInGraphFor: "	
		setMareaMaterialization;
		materializeFrom: aStream.
	^ materialization



! !

!MARFuelMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 2/2/2012 22:34'!
materializedObjectFrom: aStream
	^ (self materializeObjectFrom: aStream) root
	
! !

!MARFuelMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 2/2/2012 22:37'!
materializedObjectFromFileNamed: aString
	
	^ (self materializeObjectFrom: (FileDirectory default oldFileNamed: aString) binary) root
	
! !

!MARFuelMareaSerializer methodsFor: 'read - write' stamp: 'MarianoMartinezPeck 2/2/2012 22:35'!
serialize: anObject toFileNamed: aFileName
	| serialization aFileStream serializer proxyMapper analyzer | 
	aFileStream := (StandardFileStream forceNewFileNamed: aFileName) binary.
	analyzer := MARFuelAnalyzer newDefault. 
	anObject mareaIsProxy ifFalse: [
		anObject isBehavior
			ifTrue: [ analyzer considerInternalAll: (Array with: anObject)]
		].
	serializer := FLSerializer newDefault analyzer: analyzer.
	analyzer useFullMappers.
	serializer mareaSerialization.
	serialization := serializer serialize: anObject on: aFileStream.
	aFileStream close.
	self mareaLog: 'The object ', anObject mareaBasicName, ' was written on file'.
	^ serialization! !

Object subclass: #MARClassProxyInterceptor
	instanceVariableNames: ''
	classVariableNames: 'MutexProxy'
	poolDictionaries: ''
	category: 'Marea-Proxies'!

!MARClassProxyInterceptor class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/8/2011 19:00'!
initialize
	MutexProxy := Mutex new.! !

!MARClassProxyInterceptor methodsFor: 'intercepting' stamp: 'MarianoMartinezPeck 12/17/2011 01:39'!
cannotInterpret: aMessage
	| proxy context counter |

	"For the moment I remove the mutex because it brings more problems than the one it solves. In fact, there is some deadlock when materializing lots of classes."
"	MutexProxy critical: 
	["
	MARLogger logger log:  'cannotInterpret:  ', aMessage selector.
	MARLogger logger log:  'Stack:  '.
	MARLogger logger log:  '----------------'.
		
	context := thisContext sender.
	counter := 0.
	[context isNil not and: [counter < 50]] whileTrue:  [
		MARLogger logger log: context  method mareaPrintString.
		context := context sender.
		counter := counter + 1.
		].
	
	MARLogger logger log:  '----------------'.

	"We first have to find the proxy, that is, we need to search in the hierarchy the first class (or proxy) whose methodDict is nil. Usually here I should be able todo 'aMessage lookupClass mareaFindClassWithNilMethodDictInHierarchy', but in this particular case, that would lead into a system crash when swapping out classes. As an example, I have have the class XXX and its subclass YYY. We swapped XXX and now YYY has received a message. The VM see that XXX has its methodDict in nil and sends #cannotInterpret:.  If here we do 'aMessage lookupClass mareaFindClassWithNilMethodDictInHierarchy' to YYY, it will loop, because it will find again that it superclass (XXX) has the methodDict in nil. So we CANNOT send any message here because it will be trap again. We need to avoid the method lookup. For that purpose, we directly evaluate the compiled method #mareaFindClassWithNilMethodDictInHierarchy in each class of the hierarchy until we find the proxy. It is not risky to use this compiledMethod because the instance variables 'methodDict' and 'superclass' won't change they place, hence the bytecode will always be correct for classes. 
	This problem is exactly the same we have in #updateMissingSharedProxiesFrom: materializedInstances filling: dict."
	proxy := CompiledMethod receiver: aMessage lookupClass withArgs: #() executeMethod: (Behavior >> #mareaFindClassWithNilMethodDictInHierarchy).
	^ MARProxyHandler handleInterception: aMessage for: proxy receiver: self.	
	
"	]"! !

Object subclass: #MARCompiledMethodSwapper
	instanceVariableNames: ''
	classVariableNames: 'Logger ProxyClass'
	poolDictionaries: ''
	category: 'Marea-Swapping'!

!MARCompiledMethodSwapper class methodsFor: 'stuff to exclude' stamp: 'MarianoMartinezPeck 5/3/2011 17:44'!
classesNotToSwap

	| tooDangerousClasses coreClasses protoObjectSubclasses classesSpecialArray veryUsedClasses allClasses debuggingClasses nilSubclasses |

	"This are classes that are known as too dangerous."
	tooDangerousClasses := OrderedCollection new.
	(ClassBuilder new tooDangerousClasses) 
		do: [:each | Smalltalk globals at: each 
			ifPresent: [:present | tooDangerousClasses add: (Smalltalk at: each) ] 
			ifAbsent: []].
	
	"These classes because they are too core and used by the code to swapout itseld"
	coreClasses :=  {Array. Object. ProtoObject. Class. Message. MethodDictionary. CompiledMethod}. 

	"Subclasses of ProtoObject because they do not implement some methods that Object does and that are used by the swapping stuff."
	protoObjectSubclasses := ProtoObject subclasses.
	
	"These classes cannot be swapped because they are used by the VM"
	classesSpecialArray := Smalltalk specialObjectsArray select: [ :each | each isBehavior ].
	
	"These classes cannot be swapped because they install the segment (they are used) even before the segment can be written into a file"
	veryUsedClasses := { Cursor. CursorWithMask. EncodedCharSet.}.
	
	"Classes that are usually needed to debug and they help us to analyze problems"
	debuggingClasses := { DEVToolSet. }.
	
	"nil subclasses cannot be swapped out because since they don't subclass ProtoObject they may not even implement doesNotUnderstand:.
	For example, if we swap a CompiledMethod of PseudoContext, and then we try to load it back, the VM will crash with the error Recursive not understood error encountered. '"
	nilSubclasses := nil subclasses.
	
	allClasses := coreClasses, protoObjectSubclasses, classesSpecialArray, veryUsedClasses, tooDangerousClasses, debuggingClasses, nilSubclasses.
	
	^ allClasses asOrderedCollection ! !

!MARCompiledMethodSwapper class methodsFor: 'stuff to include' stamp: 'MarianoMartinezPeck 5/13/2011 10:28'!
compiledMethodsToSwap
	|  methodsToSwap classesNotToSwap packagesNotToSwap fixedMethodsNotToSwap |
	
	fixedMethodsNotToSwap := self fixedMethodsNotToSwap.
	
	UnusedObjectDiscoverer current startDiscovery. 

	self discoverMinimalUsedCompiledMethods.
	self methodsUsedByMareaTesting.
	
	packagesNotToSwap := self packagesNotToSwap.
	
	classesNotToSwap := self classesNotToSwap.
	packagesNotToSwap do: [:aPackage | classesNotToSwap addAll: aPackage classes ].
	packagesNotToSwap do: [:aPackage | fixedMethodsNotToSwap addAll: aPackage extensionMethods ].
	
	fixedMethodsNotToSwap do: [:aMethod | 	UnusedObjectDiscoverer current primitiveSetUsedBit: aMethod boolean: true].
	
	classesNotToSwap do: [:aClass | aClass markAllInstanceAndClassMethodsAsUsed].
	
	UnusedObjectDiscoverer current stopDiscovery.
	
	methodsToSwap := CompiledMethod unusedInstances.
	methodsToSwap := methodsToSwap reject: [:each | each isInstalled not ].
	
	Transcript show: 'Methods to swap: ',  methodsToSwap size asString; cr.
	Transcript show: 'Methods NOT to swap: ',  CompiledMethod usedInstances size asString; cr.
	
	^ methodsToSwap


! !

!MARCompiledMethodSwapper class methodsFor: 'stuff to exclude' stamp: 'MarianoMartinezPeck 11/27/2010 17:05'!
discoverMinimalUsedCompiledMethods
"These the minimal CompiledMethods needed to install and install a CompiledMethodProxy"
	| aProxy |
	
	SystemNavigation default browseClass: Object.
	
	aProxy := self installOn: ClassWith1Var selector: #foo.
	(ClassWith1Var methodDict at: #foo) literals.
	
	aProxy := self installOn: ClassWith1Var selector: #foo.
	ClassWith1Var new foo.! !

!MARCompiledMethodSwapper class methodsFor: 'examples' stamp: 'MarianoMartinezPeck 12/17/2011 01:39'!
exampleSwapOutAllUnusedMethods 
	"self exampleSwapOutAllUnusedMethods"
	| methodsToSwap timeToInstall timeToUninstall counter |
	"CompiledMethodProxyHandler mareaSerializer: FuelMareaSerializer. "
	CompiledMethodProxySwapperHandler serializer: MARFuelMareaSerializer new. 
	self proxyClass: NumberAsFilenameCompiledMethodProxySwapper.
	self proxyClass runningTest: false.
	self proxyClass mareaResetNumber.
	Logger := nil.
	"MareaLogger changeToFileLogger."
	MARLogger disableLogging.
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Using proxy class: ', self proxyClass name.
	self log: 'Proxies installed instances before start: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances before start: ', CompiledMethod instanceCount asString.
	self log: 'Memory used before proxies: ', (Smalltalk vmParameterAt: 3) asString.
	"self printSpaceTally.
"	methodsToSwap := self compiledMethodsToSwap.
	self proxyClass: NumberAsFilenameCompiledMethodProxySwapper.
	self proxyClass runningTest: false.
	
	
	CompiledMethodProxySwapperHandler serializer: MARFuelMareaSerializer. 
	self log: 'CompiledMethods to swap: ',  methodsToSwap size asString.
	
	counter := 0.
	"[timeToInstall := MessageTally time: ["
	methodsToSwap do: [:method| 
		"(counter \\ 5000) isZero ifTrue: [
			self log: ''."
			"self log: SmalltalkImage current vmStatisticsReportString."
			"self log: ''."
		"]. 
		counter := counter + 1."
		"self log: 'Class: ', method methodClass name asString, ' selector: ', method selector asString. "
		self installOn: method methodClass selector: method selector.].
	"]."

	self log: 'Time to install proxies: ', timeToInstall asString, ' miliseconds'.
	methodsToSwap := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies intalled: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances after installing: ', CompiledMethod instanceCount asString.
	self log: 'Memory used using proxies: ', (Smalltalk vmParameterAt: 3) asString.

	[
"	timeToUninstall := MessageTally time: [
		counter := 0.
		self proxyClass mareaAllInstalledProxies do: [:instance| 
			(counter \\ 5000) isZero ifTrue: [
				self log: ''.
				self log: SmalltalkImage current vmStatisticsReportString.
				self log: ''.
				self printSpaceTally.
			]. 
		counter := counter + 1.
		instance mareaUninstallIfNeeded
		].		
	]."

	"self proxyClass mareaUninstallIfNeededAllInstances."
	self log: 'Time to uninstall proxies: ', timeToUninstall asString, ' miliseconds'.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies installed instances after uninstalling: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Memory used after uninstalling proxies: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'CompiledMethod instances after uninstalling: ', CompiledMethod instanceCount asString.
	"self printSpaceTally."
	] ensure: [
		self log: 'Ensure....'.
		"self proxyClass mareaUninstallIfNeededAllInstances."
"		(FileDirectory default fileNamesMatching: '*.swap*') 
			do: [ :aFile | FileDirectory default deleteFileNamed: aFile ]."
	]! !

!MARCompiledMethodSwapper class methodsFor: 'examples' stamp: 'MarianoMartinezPeck 12/17/2011 01:39'!
exampleSwapOutAllUnusedMethodsAndClasses
	"self nose"
	| methodsToSwap timeToInstall timeToUninstall counter |
	"CompiledMethodProxyHandler mareaSerializer: FuelMareaSerializer. "
	CompiledMethodProxySwapperHandler serializer: MARFuelMareaSerializer new. 
	self proxyClass: NumberAsFilenameCompiledMethodProxySwapper.
	self proxyClass runningTest: false.
	self proxyClass mareaResetNumber.
	Logger := nil.
	MARLogger disableLogging.
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Using proxy class: ', self proxyClass name.
	self log: 'Methods Proxies installed instances before start: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Class Proxies installed instances before start: ', ClassProxySwapper mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances before start: ', CompiledMethod instanceCount asString.
	self log: 'Classes instances before start: ', Smalltalk allClassesAndTraits size asString.
	self log: 'Memory used before proxies: ', (Smalltalk vmParameterAt: 3) asString.
	"self printSpaceTally.
"	methodsToSwap := self compiledMethodsToSwap.
	
	CompiledMethodProxySwapperHandler serializer: MARFuelMareaSerializer. 
	self log: 'CompiledMethods to swap: ',  methodsToSwap size asString.
	
	counter := 0.
	[timeToInstall := MessageTally time: [
	methodsToSwap do: [:method| 
		(counter \\ 5000) isZero ifTrue: [
			self log: ''.
			"self log: SmalltalkImage current vmStatisticsReportString."
			self log: ''.
		]. 
		counter := counter + 1.
		self installOn: method methodClass selector: method selector.].
	].

	Smalltalk allClassesDo: [:aClass | aClass hasAllMethodsAsProxies ifTrue: [ClassProxySwapper installOn: aClass ]. ].

	self log: 'Time to install proxies: ', timeToInstall asString, ' miliseconds'.
	methodsToSwap := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Methods Proxies intalled: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances after installing: ', CompiledMethod instanceCount asString.
	self log: 'Class Proxies intalled: ',  ClassProxySwapper  mareaAllInstalledProxiesCount asString.
	self log: 'Class instances after installing: ', Smalltalk allClassesAndTraits size asString.
	
	self log: 'Memory used using proxies: ', (Smalltalk vmParameterAt: 3) asString.

"	timeToUninstall := MessageTally time: [
		counter := 0.
		self proxyClass mareaAllInstalledProxies do: [:instance| 
			(counter \\ 5000) isZero ifTrue: [
				self log: ''.
				self log: SmalltalkImage current vmStatisticsReportString.
				self log: ''.
				self printSpaceTally.
			]. 
		counter := counter + 1.
		instance mareaUninstallIfNeeded
		].		
	]."
	self log: 'Time to uninstall proxies: ', timeToUninstall asString, ' miliseconds'.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Method Proxies installed instances after uninstalling: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Class Proxies installed instances after uninstalling: ', ClassProxySwapper  mareaAllInstalledProxiesCount asString.
	self log: 'Memory used after uninstalling proxies: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'CompiledMethod instances after uninstalling: ', CompiledMethod instanceCount asString.
	self log: 'Class instances after uninstalling: ', Smalltalk allClassesAndTraits size asString.
	"self printSpaceTally."
	] ensure: [
		self log: 'Ensure....'.
		MARLogger changeToFileLogger.
		"self proxyClass mareaUninstallIfNeededAllInstances."
"		(FileDirectory default fileNamesMatching: '*.swap*') 
			do: [ :aFile | FileDirectory default deleteFileNamed: aFile ]."
	]! !

!MARCompiledMethodSwapper class methodsFor: 'examples' stamp: 'MarianoMartinezPeck 12/17/2011 14:52'!
exampleSwapOutClassesForSomePackages
	"self exampleSwapOutTestMethodsForOnePackage"
	| objectsToSwap timeToInstall timeToUninstall |
	self halt.
	MARLogger changeToTranscriptLogger.

	self proxyClass: MARRegularObjectProxy.
	MARObjectGraphSwapper resetAll.
	MARObjectGraphExporter proxyCreator: self proxyClass.
	
	self proxyClass runningTest: false.
	
	Logger := nil.
	MARLogger disableLogging.
	3 timesRepeat: [Smalltalk garbageCollect].
	Symbol compactSymbolTable.
	self log: 'Proxies installed instances before start: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances before start: ', CompiledMethod instanceCount asString.
	self log: 'Memory used before proxies: ', (Smalltalk vmParameterAt: 3) asString.
	objectsToSwap := OrderedCollection new.
(PackageInfo allPackages select: [:each| each packageName includesSubString: 'AST-Tests'] ) do: [:aPackage |
		aPackage classes do: [:aClass |
			objectsToSwap addAll: aClass methods
			].
		].
	objectsToSwap  := objectsToSwap asIdentitySet asArray.
	self log: 'CompiledMethods to swap: ',  objectsToSwap size asString.
	[
	timeToInstall := MessageTally time: [
		self halt. objectsToSwap do: [:method| self swapOut: method].
	].
	self log: 'Time to install proxies: ', timeToInstall asString, ' miliseconds'.
	objectsToSwap := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies intalled: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances after installing: ', CompiledMethod instanceCount asString.
	Symbol compactSymbolTable.
	self log: 'Memory used using proxies after compacting symbol table: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'Memory used using proxies: ', (Smalltalk vmParameterAt: 3) asString.
	timeToUninstall := MessageTally time: [self proxyClass mareaUninstallIfNeededAllInstances].
	self log: 'Time to uninstall proxies: ', timeToUninstall asString, ' miliseconds'.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies installed instances after uninstalling: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Memory used after uninstalling proxies: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'CompiledMethod instances after uninstalling: ', CompiledMethod instanceCount asString.
	] ensure: [
		self proxyClass mareaUninstallIfNeededAllInstances.
		(FileDirectory default fileNamesMatching: '*.swap*') 
			do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].
	]! !

!MARCompiledMethodSwapper class methodsFor: 'examples' stamp: 'MarianoMartinezPeck 12/17/2011 14:52'!
exampleSwapOutTestMethodsForOnePackage
	"self exampleSwapOutTestMethodsForOnePackage"
	| objectsToSwap timeToInstall timeToUninstall |
	self halt.
	MARLogger changeToTranscriptLogger.

	self proxyClass: MARRegularObjectProxy.
	MARObjectGraphSwapper resetAll.
	MARObjectGraphExporter proxyCreator: self proxyClass.
	
	self proxyClass runningTest: false.
	
	Logger := nil.
	MARLogger disableLogging.
	3 timesRepeat: [Smalltalk garbageCollect].
	Symbol compactSymbolTable.
	self log: 'Proxies installed instances before start: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances before start: ', CompiledMethod instanceCount asString.
	self log: 'Memory used before proxies: ', (Smalltalk vmParameterAt: 3) asString.
	objectsToSwap := OrderedCollection new.
(PackageInfo allPackages select: [:each| each packageName includesSubString: 'AST-Tests'] ) do: [:aPackage |
		aPackage classes do: [:aClass |
			objectsToSwap addAll: aClass methods
			].
		].
	objectsToSwap  := objectsToSwap asIdentitySet asArray.
	self log: 'CompiledMethods to swap: ',  objectsToSwap size asString.
	[
	timeToInstall := MessageTally time: [
		self halt. objectsToSwap do: [:method| self swapOut: method].
	].
	self log: 'Time to install proxies: ', timeToInstall asString, ' miliseconds'.
	objectsToSwap := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies intalled: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances after installing: ', CompiledMethod instanceCount asString.
	Symbol compactSymbolTable.
	self log: 'Memory used using proxies after compacting symbol table: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'Memory used using proxies: ', (Smalltalk vmParameterAt: 3) asString.
	timeToUninstall := MessageTally time: [self proxyClass mareaUninstallIfNeededAllInstances].
	self log: 'Time to uninstall proxies: ', timeToUninstall asString, ' miliseconds'.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies installed instances after uninstalling: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Memory used after uninstalling proxies: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'CompiledMethod instances after uninstalling: ', CompiledMethod instanceCount asString.
	] ensure: [
		self proxyClass mareaUninstallIfNeededAllInstances.
		(FileDirectory default fileNamesMatching: '*.swap*') 
			do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].
	]! !

!MARCompiledMethodSwapper class methodsFor: 'examples' stamp: 'MarianoMartinezPeck 12/19/2011 11:08'!
exampleSwapOutUnusedTestClasses
	"self exampleSwapOutUnusedTestClasses"
	| classesToSwap timeToInstall timeToUninstall |
	
	MARLogger changeToTranscriptLogger.

	MARObjectGraphSwapper resetAll.
	MARObjectGraphExporter proxyCreator: MARRegularObjectProxy.
	MARObjectGraphExporter reset.
	
	self proxyClass runningTest: false.

	Logger := nil.
	MARLogger disableLogging.
	3 timesRepeat: [Smalltalk garbageCollect].
	Symbol compactSymbolTable.
	self log: 'Proxies installed instances before start: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Metaclass instances before start: ', Metaclass instanceCount asString.
	self log: 'Memory used before proxies: ', (Smalltalk vmParameterAt: 3) asString.
	classesToSwap := OrderedCollection new.
(PackageInfo allPackages select: [:each| each packageName includesSubString: 'Test'] ) do: [:aPackage |
		aPackage classes do: [:aClass | (UnusedObjectDiscoverer current primitiveGetUsedBit: aClass) 
			ifFalse: [classesToSwap add: aClass ]. 
			].
		].
	self log: 'Metaclasss to swap: ',  classesToSwap size asString.
	[
	timeToInstall := MessageTally time: [
	classesToSwap do: [:class| self installOn: class ].
	].
	self log: 'Time to install proxies: ', timeToInstall asString, ' miliseconds'.
	classesToSwap := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies intalled: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Metaclass instances after installing: ', Metaclass instanceCount asString.
	Symbol compactSymbolTable.
	self log: 'Memory used using proxies after compacting symbol table: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'Memory used using proxies: ', (Smalltalk vmParameterAt: 3) asString.
	timeToUninstall := MessageTally time: [self proxyClass mareaUninstallIfNeededAllInstances].
	self log: 'Time to uninstall proxies: ', timeToUninstall asString, ' miliseconds'.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies installed instances after uninstalling: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Memory used after uninstalling proxies: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'Metaclass instances after uninstalling: ', Metaclass instanceCount asString.
	] ensure: [
		self proxyClass mareaUninstallIfNeededAllInstances.
		(FileDirectory default fileNamesMatching: '*.swap*') 
			do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].
	]! !

!MARCompiledMethodSwapper class methodsFor: 'examples' stamp: 'MarianoMartinezPeck 12/17/2011 14:52'!
exampleSwapOutUnusedTestMethods
	"self exampleSwapOutUnusedTestMethods"
	| objectsToSwap timeToInstall timeToUninstall |
	
	MARLogger changeToTranscriptLogger.

	MARObjectGraphSwapper resetAll.
	MARObjectGraphExporter proxyCreator: MARRegularObjectProxy.
	
	self proxyClass runningTest: false.
	
	Logger := nil.
	MARLogger disableLogging.
	3 timesRepeat: [Smalltalk garbageCollect].
	Symbol compactSymbolTable.
	self log: 'Proxies installed instances before start: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances before start: ', CompiledMethod instanceCount asString.
	self log: 'Memory used before proxies: ', (Smalltalk vmParameterAt: 3) asString.
	objectsToSwap := OrderedCollection new.
(PackageInfo allPackages select: [:each| each packageName includesSubString: 'Test'] ) do: [:aPackage |
		aPackage classes do: [:aClass |
			objectsToSwap addAll: aClass unusedMethods
			].
		].
	self log: 'CompiledMethods to swap: ',  objectsToSwap size asString.
	[
	timeToInstall := MessageTally time: [
	objectsToSwap do: [:method| self swapOut: method].
	].
	self log: 'Time to install proxies: ', timeToInstall asString, ' miliseconds'.
	objectsToSwap := nil.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies intalled: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'CompiledMethod instances after installing: ', CompiledMethod instanceCount asString.
	Symbol compactSymbolTable.
	self log: 'Memory used using proxies after compacting symbol table: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'Memory used using proxies: ', (Smalltalk vmParameterAt: 3) asString.
	timeToUninstall := MessageTally time: [self proxyClass mareaUninstallIfNeededAllInstances].
	self log: 'Time to uninstall proxies: ', timeToUninstall asString, ' miliseconds'.
	MCMethodDefinition shutDown. 
	3 timesRepeat: [Smalltalk garbageCollect].
	self log: 'Proxies installed instances after uninstalling: ', self proxyClass mareaAllInstalledProxiesCount asString.
	self log: 'Memory used after uninstalling proxies: ', (Smalltalk vmParameterAt: 3) asString.
	self log: 'CompiledMethod instances after uninstalling: ', CompiledMethod instanceCount asString.
	] ensure: [
		self proxyClass mareaUninstallIfNeededAllInstances.
		(FileDirectory default fileNamesMatching: '*.swap*') 
			do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].
	]! !

!MARCompiledMethodSwapper class methodsFor: 'stuff to exclude' stamp: 'MarianoMartinezPeck 5/3/2011 18:00'!
fixedMethodsNotToSwap
	^ self selectorsNotToSwap
		inject: OrderedCollection new
		into: [:allMethods :aSelector | 
			allMethods addAll: 
				(CompiledMethod allInstances select: [:aMethod | aMethod selector = aSelector] ); yourself 
		]! !

!MARCompiledMethodSwapper class methodsFor: 'install' stamp: 'MarianoMartinezPeck 7/6/2011 15:39'!
installOn: aClass 
	^ self proxyClass installOn: aClass! !

!MARCompiledMethodSwapper class methodsFor: 'install' stamp: 'MarianoMartinezPeck 11/21/2010 16:27'!
installOn: aClass selector:  aSelector.
	^ self proxyClass installOn: aClass selector: aSelector.! !

!MARCompiledMethodSwapper class methodsFor: 'lists' stamp: 'MarianoMartinezPeck 11/21/2010 18:32'!
listOfCorePackages
	^ self listOfCorePackagesNames collect: [:each |  PackageInfo named: each ]! !

!MARCompiledMethodSwapper class methodsFor: 'lists' stamp: 'MarianoMartinezPeck 11/21/2010 18:32'!
listOfCorePackagesNames
	"To recreate this list, you can take a PharoCore image and print:
	PackageInfo allPackages collect: [:each| each packageName] 
"

	^  #('MultilingualTests' 'Morphic' 'ToolBuilder-Kernel' 'PackageInfo' 'Polymorph-ToolBuilder' 'Network-Kernel' 'Network-Protocols' 'Compiler' 'System-Finalization' 'Settings-Graphics' 'Collections' 'Network-RemoteDirectory' 'Traits' 'Network-URI' 'Settings-Display' 'Collections-Abstract' 'Settings-Compiler' 'MonticelloMocks' 'ScriptLoader11' 'System-Digital Signatures' 'System-Localization' 'MenuRegistration' 'Polymorph-TaskbarIcons' 'Monticello' 'ToolBuilder-Morphic' 'MCDirtyPackage' 'Collections-Weak' 'Settings-Polymorph' 'Tests' 'HelpSystem-Core-Utilities' 'SUnit' 'Collections-Text' 'Compression' 'Morphic-MorphTreeWidget' 'HelpSystem-Core' 'ToolsTest' 'Gofer-Core' 'Gofer-Tests' 'Collections-Stack' 'FreeType' 'MonticelloConfigurations' 'Polymorph-Geometry' 'Collections-Support' 'SUnitGUI' 'HelpSystem-Core-Model' 'Tests-VM' 'System-Change Notification' 'System' 'Tests-ObjectsAsMethods' 'HostMenus' 'Network-MIME' 'Network-RFC822' 'VB-Regex' 'TrueType' 'DeprecatedPreferences' 'System-Clipboard' 'System-Settings' 'MorphicTests' 'System-Serial Port' 'NetworkTests' 'Collections-Unordered' 'System-Changes' 'System-Object Storage' 'Collections-Traits' 'System-Platforms' 'Tests-PrimCallController' 'Morphic-TrueType' 'Multilingual' 'Graphics' 'Collections-Strings' 'KernelTests' 'System-FileRegistry' 'Tests-Bugs' 'ToolBuilder-SUnit' 'Tests-Release' 'Morphic-Balloon' 'Settings-Network' 'System-Applications' 'Polymorph-Tools-Diff' 'Settings-Tools' 'ScriptLoader' 'ST80' 'FreeTypeSubPixelAntiAliasing' 'Settings-Kernel' 'Settings-System' 'CompilerTests' 'System-Tools' 'System-Hashing' 'System-Download' 'Collections-Streams' 'Tests-SystemChangeNotification' 'GraphicsTests' 'Polymorph-Widgets' 'Kernel' 'Tools' 'Settings-FreeType' 'FreeTypeTests' 'Settings-Monticello' 'HelpSystem-Tests' 'Polymorph-EventEnhancements' 'System-Support' 'MonticelloGUI' 'System-FilePackage' 'System-Object Events' 'Announcements' 'System-Text' 'Exceptions' 'Network-UUID' 'System-Pools' 'FixUnderscores' 'HelpSystem-Core-UI' 'GraphicsResources' 'Files' 'Gofer' 'Network-MailSending' 'Collections-Arrayed' 'CollectionsTests' 'Balloon' 'Network-Url' 'Collections-Sequenceable')! !

!MARCompiledMethodSwapper class methodsFor: 'lists' stamp: 'MarianoMartinezPeck 11/21/2010 18:32'!
listOfNotDangerousCorePackages
	^ self listOfNotDangerousCorePackagesNames collect: [:each |  PackageInfo named: each ]! !

!MARCompiledMethodSwapper class methodsFor: 'lists' stamp: 'MarianoMartinezPeck 11/22/2010 21:40'!
listOfNotDangerousCorePackagesNames
	"To recreate this list, you can take a PharoCore image and print:
	PackageInfo allPackages collect: [:each| each packageName] 
"

	^ #('Morphic' 'ToolBuilder-Kernel' 'PackageInfo' 'Polymorph-ToolBuilder' 'Network-Kernel' 'Network-Protocols' 'Compiler' 'System-Finalization' 'Settings-Graphics' 'Collections' 'Network-RemoteDirectory' 'Traits' 'Network-URI' 'Settings-Display' 'Collections-Abstract' 'Settings-Compiler' 'MonticelloMocks' 'ScriptLoader11' 'System-Digital Signatures' 'System-Localization' 'MenuRegistration' 'Polymorph-TaskbarIcons' 'Monticello' 'ToolBuilder-Morphic' 'MCDirtyPackage' 'Collections-Weak' 'Settings-Polymorph' 'HelpSystem-Core-Utilities' 'SUnit' 'Collections-Text' 'Compression' 'Morphic-MorphTreeWidget' 'HelpSystem-Core' 'Gofer-Core' 'Collections-Stack' 'FreeType' 'MonticelloConfigurations' 'Polymorph-Geometry' 'Collections-Support' 'SUnitGUI' 'HelpSystem-Core-Model' 'System-Change Notification' 'System' 'HostMenus' 'Network-MIME' 'Network-RFC822' 'VB-Regex' 'TrueType' 'DeprecatedPreferences' 'System-Clipboard' 'System-Settings' 'System-Serial Port' 'Collections-Unordered' 'System-Changes' 'System-Object Storage' 'Collections-Traits' 'System-Platforms' 'Morphic-TrueType' 'Multilingual' 'Graphics' 'Collections-Strings' 'System-FileRegistry' 'ToolBuilder-SUnit' 'Morphic-Balloon' 'Settings-Network' 'System-Applications' 'Polymorph-Tools-Diff' 'Settings-Tools' 'ScriptLoader' 'ST80' 'FreeTypeSubPixelAntiAliasing' 'Settings-Kernel' 'Settings-System' 'System-Tools' 'System-Hashing' 'System-Download' 'Collections-Streams' 'Polymorph-Widgets' 'Kernel' 'Tools' 'Settings-FreeType' 'Settings-Monticello' 'Polymorph-EventEnhancements' 'System-Support' 'MonticelloGUI' 'System-FilePackage' 'System-Object Events' 'Announcements' 'System-Text' 'Exceptions' 'Network-UUID' 'System-Pools' 'FixUnderscores' 'HelpSystem-Core-UI' 'GraphicsResources' 'Files' 'Gofer' 'Network-MailSending' 'Collections-Arrayed' 'Balloon' 'Network-Url' 'Collections-Sequenceable')! !

!MARCompiledMethodSwapper class methodsFor: 'logging' stamp: 'MarianoMartinezPeck 11/30/2010 13:27'!
log: aString
	self logger log: aString ! !

!MARCompiledMethodSwapper class methodsFor: 'logging' stamp: 'MarianoMartinezPeck 11/30/2010 13:32'!
logger	
	Logger isNil ifTrue: [
		Logger := FixesFileNameLoggerStrategy named: 'Swapper.txt'.
		Logger startLogging].
	^ Logger! !

!MARCompiledMethodSwapper class methodsFor: 'stuff to exclude' stamp: 'MarianoMartinezPeck 11/30/2010 18:09'!
methodsUsedByMareaTesting
	| suite |
	suite := TestSuite named: 'zaraza'. 
	AbstractCompiledMethodProxyTest withAllSubclasses do: [:each |
		TestCase addTestsFor: each name toSuite: suite.].
	suite tests: (suite tests reject: [:each | each testSelector = #testCompiledMethodProxyAndGC]). 
	suite run. 
 ! !

!MARCompiledMethodSwapper class methodsFor: 'stuff to exclude' stamp: 'MarianoMartinezPeck 5/13/2011 13:58'!
packagesNotToSwap.
	"Notice that this is the strict way. If there are errors difficult to debug I would uncomment the commented ones and try."
	^ (# ("'System-Object Storage'" 'Fuel' 'Kernel' "'Graphics'" 'Exceptions' 'Proxies' "'Settings' ""'System'" 'UsedObject' "'Traits'" "'Balloon'" 'Tools-Base' "'Morphic'" "'ToolBuilder'" 'Compiler' ) collect: [:aPackageName | PackageInfo named: aPackageName]),
	(PackageInfo allPackages select: [:each | each packageName includesSubString: 'Collections-' ])
	
! !

!MARCompiledMethodSwapper class methodsFor: 'logging' stamp: 'MarianoMartinezPeck 12/2/2010 16:04'!
printSpaceTally
	self log: ''.
	self log: ''.
	SpaceTally new printSpaceAnalysis: 1 on: self logger logFile maxResults: 10. 
	self log: ''.
	self log: ''.! !

!MARCompiledMethodSwapper class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/21/2010 16:24'!
proxyClass
	^ ProxyClass! !

!MARCompiledMethodSwapper class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 11/21/2010 16:25'!
proxyClass: aProxyClass
	ProxyClass := aProxyClass.! !

!MARCompiledMethodSwapper class methodsFor: 'stuff to exclude' stamp: 'MarianoMartinezPeck 5/3/2011 18:06'!
selectorsNotToSwap
	^ #(#class #DoIt), (Smalltalk specialObjectsArray select: [:each | each isSymbol])
	
! !

!MARCompiledMethodSwapper class methodsFor: 'install' stamp: 'MarianoMartinezPeck 12/17/2011 01:34'!
swapOut: anObject
	MARObjectGraphExporter new swapOutGraph: anObject.
! !

Object subclass: #MARFileBasedGraphPersistency
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Swapping'!

!MARFileBasedGraphPersistency class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/1/2012 23:35'!
graphBlobFromGraphID: graphID	
	| fileStream byteArray |
	fileStream := (FileDirectory default oldFileNamed:  (graphID asString, '.swap')) binary.
	byteArray := fileStream contents.
	fileStream close.
	^ byteArray! !

!MARFileBasedGraphPersistency class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/2/2012 20:37'!
removeAllGraphs
	(FileDirectory default fileNamesMatching: '*.swap*') 
		do: [ :aFile | FileDirectory default deleteFileNamed: aFile ].
	! !

!MARFileBasedGraphPersistency class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/2/2012 19:52'!
removeGraphWithID: graphID
	FileDirectory default deleteFileNamed: (graphID asString, '.swap').
	! !

!MARFileBasedGraphPersistency class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/2/2012 20:50'!
reset
	self removeAllGraphs 
	! !

!MARFileBasedGraphPersistency class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/1/2012 23:30'!
storeGraphBlob: aByteArray graphID: graphID	
	| fileStream |
	fileStream := (StandardFileStream forceNewFileNamed: (graphID asString, '.swap')) binary.
	fileStream nextPutAll: aByteArray.
	fileStream close.! !

Object subclass: #MARForwardingPointer
	instanceVariableNames: 'proxyID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Proxies'!

!MARForwardingPointer class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/9/2012 11:39'!
initialize
	self becomeCompact.! !

!MARForwardingPointer methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/9/2012 10:59'!
mareaGraphID
	^ proxyID bitAnd: 2r111111111111111! !

!MARForwardingPointer methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/9/2012 11:00'!
mareaPosition
	^ proxyID >> 15 
	! !

!MARForwardingPointer methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/9/2012 11:00'!
mareaSetPosition: aPosition setGraphID: aGraphID
	(aPosition > 65535) ifTrue: [ MARPositionBiggerThanMax new signal: 'MAREA_ERROR: The position of the proxy is bigger than the maximum. The graph cannot be swapped'. ].
	(aGraphID > 32767) ifTrue: [ MARGraphIDBiggerThanMax new signal: 'MAREA_ERROR: The graphID of the proxy is bigger than the maximum. The graph cannot be swapped'. ].
	proxyID :=  (aGraphID bitAnd: 16rFFFF) bitOr: (aPosition << 15).
! !

!MARForwardingPointer methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 1/9/2012 11:01'!
proxyID
	^ proxyID! !

!MARForwardingPointer methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 1/9/2012 11:01'!
proxyID: anObject
	proxyID := anObject! !

Object subclass: #MARInterception
	instanceVariableNames: 'message receiver target proxy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Proxies'!

!MARInterception class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 13:53'!
for: aMessage target: aTargetObject proxy: aProxy receiver: aReceiver
	^ self new initializewith: aMessage 
		target: aTargetObject
		proxy: aProxy 
		receiver: aReceiver ! !

!MARInterception methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 4/21/2011 13:39'!
initializewith: aMessage target: aTargetObject proxy: aProxy  receiver: aReceiver 
	message := aMessage.
	target := aTargetObject.
	proxy := aProxy.
	receiver := aReceiver.! !

!MARInterception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
message
	^ message! !

!MARInterception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
message: anObject
	message := anObject! !

!MARInterception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
proxy
	^ proxy! !

!MARInterception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
proxy: anObject
	proxy := anObject! !

!MARInterception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
receiver
	^ receiver! !

!MARInterception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
receiver: anObject
	receiver := anObject! !

!MARInterception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
target
	^ target! !

!MARInterception methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 4/21/2011 13:52'!
target: anObject
	target := anObject! !

Object subclass: #MARLogger
	instanceVariableNames: ''
	classVariableNames: 'ProxiesLoggerHolder'
	poolDictionaries: ''
	category: 'Marea-Logging'!

!MARLogger class methodsFor: 'change loggers' stamp: 'MarianoMartinezPeck 10/20/2010 15:27'!
changeToFileLogger
	"ProxiesLogger changeToFileLogger"
	^ self initialize! !

!MARLogger class methodsFor: 'change loggers' stamp: 'MarianoMartinezPeck 10/20/2010 15:25'!
changeToTranscriptLogger
	| logger |
	logger := SimpleLogger new.
	logger strategy: TranscriptLoggerStrategy new. 
	logger startLogging.
	ProxiesLoggerHolder := logger.! !

!MARLogger class methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 12/13/2011 12:30'!
createAndSetLogger
	ProxiesLoggerHolder := self createLogger.! !

!MARLogger class methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 1/3/2012 11:49'!
createLogger
	| logger |
	logger := SimpleLogger new.
	logger strategy: (FixesFileNameLoggerStrategy named: 'MareaLog.txt'). 
	logger startLogging.
	^ logger! !

!MARLogger class methodsFor: 'change loggers' stamp: 'MarianoMartinezPeck 10/20/2010 15:28'!
disableLogging
	| logger |
	logger := SimpleLogger new.
	logger strategy: NullLoggerStrategy new. 
	logger startLogging.
	ProxiesLoggerHolder := logger.! !

!MARLogger class methodsFor: 'examples' stamp: 'MarianoMartinezPeck 10/22/2010 17:23'!
example
	MyAppLogger logger mareaLog: 'zaraza'
	"Actually the idae is that you can create a method *MyAppLogger in Object that does:
	log: anObject
		MyAppLogger logger log: anObject
	
	So after, everywhere in your app you can just do self log: 'something'.
	"
	! !

!MARLogger class methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 2/2/2012 11:04'!
initialize 
	ProxiesLoggerHolder := self createLogger.
	Smalltalk addToShutDownList: self.
	Smalltalk addToStartUpList: self.! !

!MARLogger class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/20/2010 15:15'!
logger
	ProxiesLoggerHolder
		ifNil: [ProxiesLoggerHolder := self createLogger].
	^ ProxiesLoggerHolder! !

!MARLogger class methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 2/2/2012 14:43'!
reopenStreamIfExists
	self logger reopenStreamIfClosed! !

!MARLogger class methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 12/12/2011 21:50'!
shutDown
! !

!MARLogger class methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 2/2/2012 14:42'!
startUp
	self reopenStreamIfExists! !

!MARLogger methodsFor: 'seeClassSide' stamp: 'MarianoMartinezPeck 11/25/2010 17:16'!
seeClassSide ! !

Object subclass: #MARObjectGraphSwapper
	instanceVariableNames: 'graphID proxiesDict'
	classVariableNames: 'GraphPersistencyStrategy GraphTable IDGenerator Logger NotBecomedObjects SharedProxiesTable'
	poolDictionaries: ''
	category: 'Marea-Swapping'!

MARObjectGraphSwapper subclass: #MARObjectGraphExporter
	instanceVariableNames: 'serialization objectsNotProxified classPoolCluster'
	classVariableNames: 'ProxyCreator'
	poolDictionaries: ''
	category: 'Marea-Swapping'!

!MARObjectGraphExporter class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/20/2011 14:30'!
newProxyFor: anObject
	^ ProxyCreator createProxyFor: anObject
! !

!MARObjectGraphExporter class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/20/2011 12:52'!
proxyCreator
	ProxyCreator isNil ifTrue: [ ProxyCreator := self realProxyCreator. ].
	^ ProxyCreator! !

!MARObjectGraphExporter class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/20/2011 12:53'!
proxyCreator: aProxyCreator
	ProxyCreator := aProxyCreator.! !

!MARObjectGraphExporter class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/20/2011 12:53'!
realProxyCreator
	MARProxyTrap nilMethodDict.
	^ MARProxyCreator ! !

!MARObjectGraphExporter class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/20/2011 10:48'!
reset 
	MARFuelCachedMareaSerializer cachedAnalyzer: nil.! !

!MARObjectGraphExporter class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/20/2011 10:48'!
serializer 
	^ MARFuelCachedMareaSerializer! !

!MARObjectGraphExporter methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 1/9/2012 10:37'!
addObjectToGlobalNotBecomedObjects: anObject proxy: aProxy
	self class globalNotBecomedObjects 
		at: anObject 
		ifPresent: [:proxies | proxies add: aProxy ] 
		ifAbsent: [ self class globalNotBecomedObjects at: anObject put: (OrderedCollection with: aProxy) ]
						! !

!MARObjectGraphExporter methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 1/2/2012 17:56'!
allInternalClassesOf: aClass
	| internalClasses |
	internalClasses := OrderedCollection new. 
	internalClasses add: aClass.
	internalClasses add: aClass class.
	aClass allSubclassesDo: [:each | 
		internalClasses add: each.
		internalClasses add: each class.
	].
	^ internalClasses! !

!MARObjectGraphExporter methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 2/2/2012 10:56'!
analyze: anObject ifNeedsBecomeDo: becomeBlock ifNeedsForwardingPointerDo: forwardingBlock
	self flag: #todo.
	"I should really clean this list or at least understand which each of the lines is needed."
	
	"Symbol instances are unique, global and shared. Moreoever, they are usually used by the VM, for example, for the method lookup. Hence, becoming symbols may crash the VM. For the same reason, they do not need forwarding pointers. Even if Strings are not shared, they have a lot of problems when we become them. because of thise reason, we avoid them as well."
	(anObject isString) ifTrue: [^ self]. 
	
	 (anObject mareaClass == SmallInteger) ifTrue: [^ self].
	
	"These do not need forwarding pointer because they are automatically correctly restored"
	(anObject isBehavior or: [anObject isTrait]) ifTrue: [^ self].
	
	"Actually, I should check if it is an Association in Smalltalk globals or in ClassPools. But for the moment, at least we create forwarding pointers" 
	anObject isVariableBinding ifTrue: [ 
		((self isGlobalAssociation: anObject) or: [self isClassPoolAsociation: anObject ])
			ifTrue: [ ^ self ]
		      ifFalse: [^ forwardingBlock value]
		].
	
	"These do not need forwarding pointer because when materialized they will be identical"
	(anObject == Smalltalk globals) ifTrue: [^ self].
	
	anObject isCompiledMethod ifTrue: [ ^ self]. 
	
	"These do not need forwarding pointer because when materialized they will be identical"
	(Smalltalk specialObjectsArray identityIncludes: anObject) ifTrue: [^ self].
	
	"Characters whose value is less than 256 are also global and shared, and sometimes uses by primitives. We do not swap them. For the same reason, they do not need forwarding pointers"
	(anObject isCharacter and: [anObject isOctetCharacter]) ifTrue: [^ self]. 
	
	((anObject == DateAndTime localTimeZone) or: [anObject == DateAndTime localTimeZone offset]) ifTrue: [^ forwardingBlock value].
	
	"(anObject isMorph) ifTrue: [^ self]. "
 

	"I still don't understand exactly why, but it seems there are probems when creating proxies for methods which are not installed in classes. So we avoid them. Another problem happens with self evaluating methods such as those created for do-its. "
	(anObject isCompiledMethod and: [ anObject mareaIsInstalled not]) ifTrue: [^ self].
	
	"When we create an instance of TextConverter, its gets the value of a class variable latin1Map and set it as instance variable. If we do a become of this, the VM crash. Hence, I cannot become that ByteArray"
	(anObject == UTF8TextConverter latin1Map) ifTrue: [^ self].
	
	"These do not need forwarding pointer because when materialized they will be identical"
	(MARFuelFullGlobalMapper includesGlobalObject: anObject) ifTrue: [^ self].

	(anObject == World worldState) ifTrue: [^ self].
	
	((anObject mareaClass == Color) and: [Color classPool identityIncludes: anObject]) ifTrue: [^ forwardingBlock value].

	 becomeBlock value.


! !

!MARObjectGraphExporter methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 1/5/2012 16:44'!
becomeOriginalObjectsToProxies

	"Finally, do a bulk become betwee the original objects and the proxies"

	proxiesDict keys elementsForwardIdentityTo: proxiesDict values.
	self mareaLog: 'Original objects becomed proxies'.! !

!MARObjectGraphExporter methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 1/9/2012 11:33'!
classesWhoseInstancesCannotBeBecomed 
	^ { SmallInteger.  }
	
"	(anObject class = Array) ifTrue: [^ false]. 
	(anObject class = ByteArray) ifTrue: [^ false]. 
	(anObject class = Rectangle) ifTrue: [^ false]. 
	(anObject class = LayoutProperties) ifTrue: [^ false]. 


	(anObject isCharacter) ifTrue: [^ false]. 
	(anObject isFloat) ifTrue: [^ false]. 	
	(anObject isPoint) ifTrue: [^ false]. 	
	(anObject isColor) ifTrue: [^ false]. 
	(anObject class = Bitmap) ifTrue: [^ false]. 
	(anObject isNumber) ifTrue: [^ false]. 
	(anObject class = Process ) ifTrue: [^ false]. 	
	(anObject isContext ) ifTrue: [^ false]. 	"
! !

!MARObjectGraphExporter methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 12/20/2011 15:37'!
createAndPutProxiesForInternalClass: aClass

	(self allInternalClassesOf: aClass) 
		do: [:each | proxiesDict at: each put: (self createProxyFor: each) ]
	! !

!MARObjectGraphExporter methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 1/26/2012 14:47'!
createProxyFor: anObject
	| proxy |
	proxy := self class newProxyFor: anObject.
	"Now that the graph was serialized, I need to set to each proxy, its associated relative offset in the stream. This is necessary when we need to uninstall the proxy and the back the become. We need to know who to do the became with.
	It may happen that one of the original objects of the graph is not in the list of serialized objects. This is because usually, serializers like Fuel do some optimizations for certain classes and instead of traversing all its instances, they just serialize something smaller and different, like a number. An example, is the class Date. The instance variables 'start duration' are not traversed. Instead, Fuel serializes just a number that represents the Date. So, in this case, we will create a proxy for an object that it is not serialized. This is a problem and I don't really know how to solve to far. Luckily, it is not a very common case.' "
	proxy mareaSetPosition: (serialization objectsIndexes at: anObject ifAbsent: [0]) setGraphID: graphID.
	^ proxy! !

!MARObjectGraphExporter methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 1/10/2012 14:42'!
isClassPoolAsociation: anObject

	^ classPoolCluster isNil ifTrue: [false] ifFalse: [classPoolCluster classOwnerByAssociation identityIncludesAssociation: anObject]! !

!MARObjectGraphExporter methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 1/10/2012 14:43'!
isGlobalAssociation: anObject
	^ Smalltalk globals identityIncludesAssociation: anObject! !

!MARObjectGraphExporter methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 2/2/2012 19:41'!
serialize: anObject
	
	^ self serialize: anObject withInternalClasses: #(). 
	
	
	! !

!MARObjectGraphExporter methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 2/2/2012 19:37'!
serialize: aClass withInternalClasses: classes

	| stream | 
	stream := WriteStream on: (ByteArray new: 100).
	serialization := self serializer serialize: aClass withInternalClasses: classes to: stream.
	self graphPersistencyStrategy storeGraphBlob: stream contents graphID: graphID.
	^ serialization
! !

!MARObjectGraphExporter methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 2/2/2012 19:41'!
serializeAllInstancesAndAllInternalClassesOf: aClass 

	"We serialize the graph and we answer the serialization object"
	^ self serialize: (Array with: aClass with: aClass allSubInstances) withInternalClasses: (self allInternalClassesOf: aClass). 
	! !

!MARObjectGraphExporter methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 2/2/2012 19:41'!
serializeAllInternalClassesOf: aClass
	
	"We serialize the graph and we answer the serialization object"
	^ self serialize: aClass withInternalClasses: (self allInternalClassesOf: aClass). 
	! !

!MARObjectGraphExporter methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 12/19/2011 09:57'!
serializer
	^ self class serializer! !

!MARObjectGraphExporter methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 2/2/2012 19:51'!
swapOutClass: aClass

	self validateClass: aClass.
	self mareaLog: 'Starting to swap out class: ', aClass name asString.
	graphID := self nextAvailableID.
	serialization := self serializeAllInternalClassesOf: aClass.
	self mareaLog: 'The graph with ID: ', graphID asString, ' was serialized.'.
		
	[self traverseGraphAndCreateProxies.
	self createAndPutProxiesForInternalClass: aClass. 

	self becomeOriginalObjectsToProxies.
	self updateGlobalGraphTable.
	] on: Error do: [:err | 
		self graphPersistencyStrategy removeGraphWithID: graphID.
		err pass.
		 ].

	proxiesDict := nil.
	serialization := nil.
	
	"At this moment, having done the bulk become and set the dict to nil, there are several objects that can be garbage collected: ALL original objects of the graph, no matter whether they are inner or shared. And ALL proxies that were associated with inner objects. The only proxies that are reachable, hence not garbage collected, are the proxy for the root of the graph, and the proxies for facade objects. Of course, notice that the whole object memory graph can change, and for example, it may happen that nobody else point to the root (now proxy) of the graph or to facade objects. If that happens, then those proxies are garbage collected as well "
	
	self flag: #todo.
	"This is needed becasuse some crashes happens when swapping out classes. However, notice we don't do a #garbageCollect but #primitiveGarbageCollect. This is because  #garbageCollect apart from the primitive of the GC it sends Object flushDependents and  Object flushEvents.  It may happen that the graph we are swapping out has references from the dependents from example. So when we are swapping out and we call #garbageCollect it will intercept the message #removeDependent: causing to swap in."
	Smalltalk primitiveGarbageCollect.
	
	self mareaLog: 'Swapping out finalized.'.! !

!MARObjectGraphExporter methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 2/2/2012 20:09'!
swapOutClassWithInstances: aClass

	self validateClass: aClass.
	self mareaLog: 'Starting to swap out class: ', aClass name asString.
	graphID := self nextAvailableID.
	serialization := self serializeAllInstancesAndAllInternalClassesOf: aClass.
	self mareaLog: 'The graph with ID: ', graphID asString, ' was serialized.'.
		
	[self traverseGraphAndCreateProxies.
	self createAndPutProxiesForInternalClass: aClass. 

	self becomeOriginalObjectsToProxies.
	self updateGlobalGraphTable.
	] on: Error do: [:err | 
		self graphPersistencyStrategy removeGraphWithID: graphID.
		err pass.
		 ].

	proxiesDict := nil.
	serialization := nil.
	
	"At this moment, having done the bulk become and set the dict to nil, there are several objects that can be garbage collected: ALL original objects of the graph, no matter whether they are inner or shared. And ALL proxies that were associated with inner objects. The only proxies that are reachable, hence not garbage collected, are the proxy for the root of the graph, and the proxies for facade objects. Of course, notice that the whole object memory graph can change, and for example, it may happen that nobody else point to the root (now proxy) of the graph or to facade objects. If that happens, then those proxies are garbage collected as well "
	
	self flag: #todo.
	"This is needed becasuse some crashes happens when swapping out classes. However, notice we don't do a #garbageCollect but #primitiveGarbageCollect. This is because  #garbageCollect apart from the primitive of the GC it sends Object flushDependents and  Object flushEvents.  It may happen that the graph we are swapping out has references from the dependents from example. So when we are swapping out and we call #garbageCollect it will intercept the message #removeDependent: causing to swap in."
	"Smalltalk primitiveGarbageCollect."
	
	self mareaLog: 'Swapping out finalized.'.! !

!MARObjectGraphExporter methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 2/2/2012 20:09'!
swapOutGraph: anObject

	self validateObject: anObject.
	self mareaLog: 'Starting to swap out graph.'.
	graphID := self nextAvailableID.
	serialization := self serialize: anObject.
	self mareaLog: 'The graph with ID: ', graphID asString, ' was serialized.'.
	
	[self traverseGraphAndCreateProxies.
	self becomeOriginalObjectsToProxies.
	self updateGlobalGraphTable.
	] on: Error do: [:err | 
		self graphPersistencyStrategy removeGraphWithID: graphID.
		err pass.
		 ].

	proxiesDict := nil.
	serialization := nil.
	
	"At this moment, having done the bulk become and set the dict to nil, there are several objects that can be garbage collected: ALL original objects of the graph, no matter whether they are inner or shared. And ALL proxies that were associated with inner objects. The only proxies that are reachable, hence not garbage collected, are the proxy for the root of the graph, and the proxies for facade objects. Of course, notice that the whole object memory graph can change, and for example, it may happen that nobody else point to the root (now proxy) of the graph or to facade objects. If that happens, then those proxies are garbage collected as well "
	
	self mareaLog: 'Swap out finalized.'.! !

!MARObjectGraphExporter methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 2/1/2012 20:48'!
traverseGraphAndCreateProxies
	"We traverse the graph and, for each object, we create a proxy for it. Traversing the original object graph can be complicated because we need to take into account global objects like Smalltalk globals so that to avoid traversing almost all image. Fuel already deals with that problem, hence we can use the serialized instances by Fuel, that is, objectsIndexes. 
	They are added to an IdentityDictionary. Each key of the dict is an original object of the graph. The value associated with each key, is the proxy created for that object. If we find a proxy as part of the graph, we do not create a proxy for the proxy, but instead, we directly use the same proxy instance. Notice that it is common to find proxies inside the graph to swap out. This happens with objects that are shared between graphs and some of thise graphs were already swapped out.
	Notice that in this case we reusing the traversal of the serializer, and not  traversing the whole original graph. This has two problems:
	- The serializer also traverse objects outside the graph, for example, the classes of the objects we serialize. See #shouldCreateProxyFor: for more details.
	- The serializer does some optimization for certain classes, like Time, Date, etc, where it does NOT traverse all its instance variables, but instead it just serialize a number that represents it. Hence, we are not really traversing the whole graph. For this aspect, it is even better to do this instead of traversing the orignal graph. Becauese we have be creating a proxy that we will not be able to retrieve back the original object to which we should do the become, because the original object was not even serialized in the stream. "

	| proxy |

	classPoolCluster := serialization clusters detect: [:each | each class = FLGlobalClassPoolAssociationCluster ] ifNone: [ ].
	proxiesDict := IdentityDictionary new.
	objectsNotProxified := OrderedCollection new. 
	serialization objectsIndexes keysDo: [:anObject | 
	"We traverse the graph and, for each object, we create a proxy for it. They are added to an IdentityDictionary. Each key of the dict is an original object of the graph. The value associated with each key, is the proxy created for that object. If we find a proxy as part of the graph, we do not create a proxy for the proxy, but instead, we directly use the same proxy instance. Moreever, in this case, we need to add this shared proxy in a table which is non-weak in order to not loose shared proxies. 
	Notice that it is common to find proxies inside the graph to swap out. This happens with objects that are shared between graphs and some of thise graphs were already swapped out.
	Finally, there are objects that cannot be #becomed like SmallIntegers. Hence we must avoid them. "
		anObject mareaIsProxy
			ifTrue: [ 
				self globalSharedProxiesTable at: anObject mareaProxyID ifAbsentPut: [anObject].
				 ]
			ifFalse: [
				self analyze: anObject
					ifNeedsBecomeDo: [ proxiesDict at: anObject put: (self createProxyFor: anObject)]
					ifNeedsForwardingPointerDo: [
						"If we cannot proxify/become an object, the we need to keep a pointer to it, so that in materialization I can fetch that object. Otherwise, the materialized graph will be different than the original since there will be objects pointing to a 'copy' of the objects we didn't proxofy. See #testObjectCannotBeProxified" 
						proxy := MARForwardingPointer new.
						proxy mareaSetPosition: (serialization objectsIndexes at: anObject ifAbsent: [0]) setGraphID: graphID.
						self addObjectToGlobalNotBecomedObjects: anObject proxy: proxy.
						]
					].	
			].
	
	self mareaLog: 'The graph was traversed and proxies were created'.
! !

!MARObjectGraphExporter methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 1/9/2012 18:17'!
updateGlobalGraphTable
	
	"There is a global table that keeps an entry per swapped graph. It is important to know which proxies there are for a certain graph, because when a proxy receives a message and it needs to load back the graph, it needs to known all the rest of the proxies that need the become as well. Hence, we keep a weak list of the proxies of the graph."
	self globalGraphTable at: graphID put: (WeakArray withAll: proxiesDict values).

! !

!MARObjectGraphExporter methodsFor: 'validation' stamp: 'MarianoMartinezPeck 1/3/2012 11:40'!
validateClass: aClass
	
	self validateObject: aClass.
	aClass hasProxifiedSubclass ifTrue: [ 
		MARClassHasProxifiedSubclass signal: 'MAREA_ERROR: The class to swap out ',  aClass name, ' cannot be profified if it has a proxified subclass'.
		^ self
		].! !

!MARObjectGraphExporter methodsFor: 'validation' stamp: 'MarianoMartinezPeck 2/1/2012 20:47'!
validateObject: anObject

	anObject mareaIsProxy ifTrue: [
		MARObjectAlreadyProxified new signal: 'MAREA_ERROR: The object to swap out is already the proxy: ', anObject mareaPrintString.
		^ self.
		].! !

MARObjectGraphSwapper subclass: #MARObjectGraphImporter
	instanceVariableNames: 'materialization needRehash'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Swapping'!

!MARObjectGraphImporter methodsFor: 'swap in' stamp: 'MarianoMartinezPeck 12/15/2011 14:00'!
becomeProxiesToMaterializedObjects
	
	proxiesDict keys elementsForwardIdentityTo: proxiesDict values.	! !

!MARObjectGraphImporter methodsFor: 'swap in' stamp: 'MarianoMartinezPeck 12/15/2011 11:59'!
executeFuelAfterMaterializationStep

	" When we materialize we make sure that Fuel does NOT run the #afterMaterializationStep. This is because since we didnt update our proxies to the materialized classes, we can have random errors. For example, if Fuel sends #fuelInitializeTraitComposition  we will be adding the materialized class 2 times, once there and the other one once we have become the proxies (since the TraitComposition has already a pointer to the proxy). So now that we have done the become, we can run the #afterMaterializationStep 	 "	
	materialization afterMaterializationStep.	
! !

!MARObjectGraphImporter methodsFor: 'swap in' stamp: 'MarianoMartinezPeck 1/12/2012 10:45'!
executePostMaterializationActionsWith: anObject

	self flag: #fixit.
	"This is not really working because the proxy doesnt necessary need to be the sharedPool, it may have been swapped in by a regular object proxy of the sharedPool, in which case the following is never executed"
	(anObject mareaIsProxy not and: [anObject isKindOf: SharedPool]) ifTrue: [
		self fixReferencesToSharedPool:  anObject.
	].
	self executeFuelAfterMaterializationStep.
	materialization internalBehaviors do: [:each | each rebindMethodDictionary].
	"This is necessary because in #updateNotBecomedObjects I become materialized objects to objects I have in the globalNotBecomedObjects table. Hence, the idenityHash of the objects of globalNotBecomedObjects were changed. Because of this, I need to do a rehash."
	self rehashGlobalNotBecomedObjectsIfNeeded.! !

!MARObjectGraphImporter methodsFor: 'swap in' stamp: 'MarianoMartinezPeck 12/15/2011 13:51'!
fixReferencesToSharedPool: aSharedPool
	"This is an ugly hack but I didn't have other idea. The problem is that there can be a class which is in the image and it is using a certain sharedPool. If such pool is swapped back and then swapIn again, then the compiled mehtods of the classes present in the image that refers to class variables of the sharedPool will be pointing to an incorrect (old) instance of the association. This COULD be solved if we create proxies por them also, but that doesn't work because when such compiled methods are executed, since those classVars (transformed in proxies) do not receive a message the proxy is not intercepted and hence the CompiledMethod execution is wrong. So, we do not create proxies for the associations of the classPool when we are swapping a SharedPool, and this is why those compiled methods hold a reference to them. But now, when the sharedPool is materialized, those CM must be updated so that the point to the correct classVar. To do this, we do the #compileAll."
	Smalltalk mareaAllClassesAndTraitsWithoutProxiesDo: [ :each | 
		(each sharedPools identityIncludes: aSharedPool) 
			ifTrue: [ each compileAll 
				] 	
		].
! !

!MARObjectGraphImporter methodsFor: 'swap in' stamp: 'MarianoMartinezPeck 2/2/2012 18:19'!
materialize
	
	"We get the ID and we search a file named as the ID. Then we materialize it."
	| stream |
	stream :=  (self graphPersistencyStrategy graphBlobFromGraphID: graphID) readStream.
	^ MARFuelMareaSerializer newDefault materializeObjectFrom: stream
! !

!MARObjectGraphImporter methodsFor: 'swap in' stamp: 'MarianoMartinezPeck 1/9/2012 17:34'!
rehashGlobalNotBecomedObjectsIfNeeded
	needRehash ifTrue: [ MARObjectGraphSwapper globalNotBecomedObjects rehash ]! !

!MARObjectGraphImporter methodsFor: 'swap in' stamp: 'MarianoMartinezPeck 2/2/2012 20:25'!
swapInGraphFor: aProxy
	"So....a proxy has received a message and hence it needs to be uninstalled: it has to read the file from disc, materialize back the original graph and to the become back between all the proxies of the graph and the just materialized objects "

	self mareaLog: 'Starting to swap in a graph.'.
	
	"We could throw  MARObjectIsNotProxy but we prefer to do nothing because sometimes we are swapping out a lot of stuff and suddenly if this problem happens, the debugger opens and the debugger swaps in everything...."
	aProxy mareaIsProxy ifFalse: [ self mareaLog: 'The object to swap in is not a proxy'. 
		^ aProxy ].
	
	"We get the ID and we search a file named as the ID. Then we materialize it."	
	graphID := aProxy mareaGraphID.
	materialization := self materialize.
	self mareaLog: 'The graph with ID: ', graphID asString, ' was materialized.'.
	
	 "Now we need to become all the proxies of the graph to the new materialized objects"
	proxiesDict := IdentityDictionary new.
	self updateProxiesOfGraph.
	self updateMissingSharedProxies.	
	self updateNotBecomedObjects.
	self mareaLog: 'Proxies were updated'.	
	self becomeProxiesToMaterializedObjects.
	self mareaLog: 'Proxies becomed materialized objects'.
	
	self executePostMaterializationActionsWith: aProxy.
	
	"Finally we clean the global table. It may happen that several proxies of the same graph have received a message and both are trying to swap in. Hence, it may happen that at this time, there is no entry in the table for this graphID, meaning the graph has already been swapped in. In such a case, there is nothign else to do."
	self globalGraphTable removeKey: graphID ifAbsent: [  ].
	
	"Once everything was done sucessfully we remove the graph"
	self graphPersistencyStrategy removeGraphWithID: graphID.
	
	self mareaLog: 'Swap in finalized with receiver object: ', aProxy printString, ' and idenityHahs: ', aProxy identityHash asString.
	
	"We need to answer the original object which was becomed with aProxy. But since it was become, the instVar aProxy is the correct one."
	^ aProxy
	! !

!MARObjectGraphImporter methodsFor: 'swap in' stamp: 'MarianoMartinezPeck 2/2/2012 19:03'!
updateMissingSharedProxies	
		
	"So far we have only updated the proxies which were in the proxies array of the graph. However, there can be still some proxies we need to update. We can have the following situation:
	- A graph AAA has a shared object BBB with graph CCC.
	- Graph AAA is swapped out and then CCC is swapped out. When CCC is serialized, it will serialize the proxy PB for BBB.
	- Graph AAA is swapped in.
	Now, when CCC is swapped in, in the proxies table, the reference which used to point to the proxy PB, now points to the real object B. However, we still need to update the reference from the graph C. So we need to iterate to the just materialized instances and see whether we have proxies that we need to update"
	
	materialization objects do: [:each |
		"Usually here I should be able todo 'each mareaIsProxy', but in this particular case, that would lead into a system crash when swapping out classes. As an example, I have have the class XXX and its subclass YYY. We swapped XXX and now YYY has received a message. The VM see that XXX has its methodDict in nil and sends #cannotInterpret:. When we now materialize XXX, in the 'objects' there will be pointers to its subclasses, in this example, YYY. If here we do 'each mareaIsProxy' to YYY, it will loop, because it will find again that it superclass (XXX) has the methodDict in nil. So we CANNOT send any message here because it will be trap again. To avoid that, we use #mareaClass which uses the specific bytecode which means that the method is not executed. Then we put #mareaIsProxy also in class side."
		each mareaClass mareaIsProxy 
			ifFalse: [
				each mareaIsProxy ifTrue: [
					self class globalSharedProxiesTable 
						at: each mareaProxyID
						ifPresent: [:sharedProxy |
							"We become the proxy with whatever is in the table: a proxy or the target object. If it is a proxy, we just update the reference so that we point to the same proxy. If it is not a proxy, it means that the original object was already becomed because the original graph of such obejct was swapped in. In this case, again, we become the proxy to that object."
							proxiesDict at: each put: sharedProxy.
							] ]
					]
		].	
! !

!MARObjectGraphImporter methodsFor: 'swap in' stamp: 'MarianoMartinezPeck 2/2/2012 18:24'!
updateNotBecomedObjects
	| proxy |
	needRehash := false.
	self class globalNotBecomedObjects keysAndValuesDo:  [:object :proxies |  		
		"The original object could have been proxified or garbage collected"
		(object mareaIsProxy not and: [object isNil not] ) 	
			ifTrue: [
				"There are some objects we cannot proxify that are always, such as True, False, Nil, Smalltalk, etc. Normally, the become should work because we are becoming the same object to the same object. However, it doesn't seem to work. So with the following IF, we make sure to only become the needed objects. For more details see #testObjectCannotBeProxified"
				proxy := proxies detect: [:each | each mareaGraphID = graphID] ifNone: [].
				proxy isNil ifFalse: [
					((materialization objects at: proxy mareaPosition) == object)
						ifFalse: [
							needRehash := true.
							proxiesDict at: (materialization objects at: proxy mareaPosition) put: object.].
					proxies remove: proxy.
					proxies isEmpty ifTrue: [self class globalNotBecomedObjects removeKey: object ifAbsent: []]
				]
			]
		]! !

!MARObjectGraphImporter methodsFor: 'swap in' stamp: 'MarianoMartinezPeck 1/27/2012 16:29'!
updateProxiesOfGraph

	| proxiesOfGraph |

	"It may happen that several proxies of the same graph have received a message and both are trying to swap in. Hence, it may happen that at this time, there is no entry in the table for this graphID, meaning the graph has already been swapped in. In such a case, there is nothign else to do."
	proxiesOfGraph := self globalGraphTable at: graphID ifAbsent: [ ^ self ].
	
	proxiesOfGraph do: [:each | 
		"Since this collection is weak, if it is nil it means it was a proxy for an object (inner or shared) which was finally garbage collected. There is nothing to do in that case. The same happens if the object is not nil, but it is a regular object (not a proxy). In this case, it should be a regular object which has been become from a previous proxy. Again, nothing to be done here. It is only necessary to do something when the object is a proxy.
		In addition, we may have put a proxy which was shared with another graph. Hence it may happen that such proxy was already uninstalled."
		each mareaIsProxy 
			ifTrue: [  
				"It doesn't matter whether the proxy is also in the shared table or not. In any case, we need to become it to the original object"
				proxiesDict at: each put: (materialization objects at: each mareaPosition)
				].				
		].
	! !

!MARObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/9/2012 11:35'!
clean
	self globalGraphTable compact.
	self globalNotBecomedObjects compact.
	self cleanGlobalSharedTable. ! !

!MARObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/6/2012 15:32'!
cleanGlobalSharedTable
	| proxiesIDs|
	proxiesIDs := IdentitySet new.
	3 timesRepeat: [Smalltalk garbageCollect].
	self globalGraphTable values do: [:each | each do: [:maybeProxy |
			maybeProxy mareaIsProxy ifTrue: [proxiesIDs add: maybeProxy mareaProxyID ] ]].
	self globalSharedProxiesTable keysDo: [:each | 
		(proxiesIDs includes: each) ifFalse: [ 	self globalSharedProxiesTable removeKey: each ].
		] 
	! !

!MARObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/15/2011 12:07'!
globalGraphTable
	GraphTable isNil ifTrue: [GraphTable := IdentityDictionary new].
	^ GraphTable! !

!MARObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/9/2012 10:30'!
globalNotBecomedObjects
	NotBecomedObjects isNil ifTrue: [NotBecomedObjects := WeakIdentityKeyDictionary  new].
	^ NotBecomedObjects! !

!MARObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/15/2011 12:07'!
globalSharedProxiesTable
	SharedProxiesTable isNil ifTrue: [SharedProxiesTable := Dictionary new].
	^ SharedProxiesTable! !

!MARObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/2/2012 18:19'!
graphPersistencyStrategy
	GraphPersistencyStrategy isNil ifTrue: [GraphPersistencyStrategy := MARFileBasedGraphPersistency ].
	^ GraphPersistencyStrategy! !

!MARObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/2/2012 20:44'!
graphPersistencyStrategy: aGraphPersistencyStrategy
	GraphPersistencyStrategy := aGraphPersistencyStrategy.! !

!MARObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/15/2011 12:07'!
nextGraphID
	IDGenerator isNil ifTrue: [IDGenerator := 0].
	IDGenerator := IDGenerator + 1.
	^ IDGenerator! !

!MARObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/6/2012 11:17'!
proxiesOfglobalGraphTableAt: anIndex
	^ (self globalGraphTable at: anIndex) select: [:each | each mareaIsProxy]! !

!MARObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/2/2012 20:35'!
resetAll
	self resetGlobalTable.
	self resetGraphID.
	self resetSharedProxiesTable.  
	self resetNotBecomedObjects.
	self resetGraphStorage.! !

!MARObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/15/2011 12:07'!
resetGlobalTable
	GraphTable := nil.! !

!MARObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/15/2011 12:07'!
resetGraphID
	IDGenerator := nil.! !

!MARObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/2/2012 20:50'!
resetGraphStorage
	self graphPersistencyStrategy reset.! !

!MARObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/9/2012 10:30'!
resetNotBecomedObjects
	NotBecomedObjects := nil.! !

!MARObjectGraphSwapper class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/15/2011 12:07'!
resetSharedProxiesTable
	SharedProxiesTable := nil.! !

!MARObjectGraphSwapper methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/15/2011 12:08'!
globalGraphTable
	^ self class globalGraphTable! !

!MARObjectGraphSwapper methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/15/2011 12:34'!
globalSharedProxiesTable
	^ self class globalSharedProxiesTable! !

!MARObjectGraphSwapper methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 2/2/2012 18:20'!
graphPersistencyStrategy
	^ self class graphPersistencyStrategy! !

!MARObjectGraphSwapper methodsFor: 'swap out' stamp: 'MarianoMartinezPeck 12/15/2011 12:08'!
nextAvailableID
	^ self class nextGraphID ! !

Object subclass: #MARObjectProxyInterceptor
	instanceVariableNames: ''
	classVariableNames: 'MutexProxy'
	poolDictionaries: ''
	category: 'Marea-Proxies'!

!MARObjectProxyInterceptor class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/8/2011 17:11'!
initialize
	MutexProxy := Mutex new.! !

!MARObjectProxyInterceptor methodsFor: 'intercepting' stamp: 'MarianoMartinezPeck 12/17/2011 01:39'!
cannotInterpret: aMessage
	|  context counter |

	"For the moment I remove the mutex because it brings more problems than the one it solves. In fact, there is some deadlock when materializing lots of classes."
"	MutexProxy critical: 
	["
	MARLogger logger log:  'cannotInterpret:  ', aMessage selector.
	MARLogger logger log:  'Stack:  '.
	MARLogger logger log:  '----------------'.
		
	context := thisContext sender.
	counter := 0.
	[context isNil not and: [counter < 50]] whileTrue:  [
		MARLogger logger log: context  method mareaPrintString.
		context := context sender.
		counter := counter + 1.
		].
	
	MARLogger logger log:  '----------------'.
		
	^ MARProxyHandler handleInterception: aMessage for: self	
"	]"

! !

MARObjectProxyInterceptor subclass: #MARProxyTrap
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Proxies'!

MARProxyTrap subclass: #MARAbstractProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Proxies'!

!MARAbstractProxy class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
allInstances
	"Answer a collection of all current instances of the receiver."

	| all inst next |
	all := OrderedCollection new.
	inst := self someInstance.
	[inst == nil]
		whileFalse: [
		next := inst mareaNextInstance.
		inst == all ifFalse: [all add: inst].
		inst := next].
	^ all asArray! !

!MARAbstractProxy class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 1/10/2012 12:11'!
allInstancesDo: aBlock 
	"Evaluate the argument, aBlock, for each of the current instances of the 
	receiver.
	
	Because aBlock might change the class of inst (for example, using become:),
	it is essential to compute next before aBlock value: inst."
	| inst next |
	inst := self someInstance.
	[inst == nil]
		whileFalse:
		[
		next := inst mareaNextInstance.
		aBlock value: inst.
		inst := next]! !

!MARAbstractProxy class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 1/4/2012 12:21'!
initialize
	self becomeCompact ! !

!MARAbstractProxy class methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
mareaAllInstalledProxies
	^ self allInstances select: [:each | each mareaIsProxyInstalled ]
 
! !

!MARAbstractProxy class methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
mareaAllInstalledProxiesCount
	^ self mareaAllInstalledProxies size
	
 
! !

!MARAbstractProxy class methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 1/10/2012 12:18'!
mareaUninstallIfNeededAllInstances
	"Be careful we cannot use #allInstancesDo:  because while enumerating the instances, we uninstall proxies, and so #nextInstance would answer something different than a proxy. At the same time, it may happen that a proxy uninstall several other proxies, so we need to always be sure that it is a proxy"
	self allInstances do: [:each | each mareaIsProxy ifTrue: [each mareaUninstallIfNeeded ] ]
 
! !

!MARAbstractProxy class methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
mareaUninstallIfNeededAllInstancesWithTracing: aLogger
	| counter |
	counter := 0.
	self allInstancesDo: [:instance| 
		(counter \\ 5000) isZero ifTrue: [
			aLogger log: ''.
			aLogger log: SmalltalkImage current vmStatisticsReportString.
			aLogger log: ''.
		]. 
	counter := counter + 1.
	instance mareaUninstallIfNeeded
	].
! !

!MARAbstractProxy class methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 12/15/2011 21:59'!
newProxy
	| newProxy |
	newProxy := self new.
	^ newProxy ! !

!MARAbstractProxy methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
asSetElement
	"Answer an object, which can be put into a Set as element , wrapped
	by one of SetElement instance, if necessary. 
	Default implementation is to answer self"
! !

!MARAbstractProxy methodsFor: 'hash' stamp: 'MarianoMartinezPeck 12/14/2011 19:45'!
basicIdentityHash
	"Answer a SmallInteger whose value is related to the receiver's identity.
	This method must not be overridden, except by SmallInteger.
	Primitive. Fails if the receiver is a SmallInteger. Essential.
	See Object documentation whatIsAPrimitive.

	Do not override. Use #identityHash unless you really know what you're doing.'"

	<primitive: 75>
	self primitiveFailed! !

!MARAbstractProxy methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
enclosedSetElement! !

!MARAbstractProxy methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 2/1/2012 14:54'!
finalize! !

!MARAbstractProxy methodsFor: 'hash' stamp: 'MarianoMartinezPeck 12/14/2011 19:45'!
identityHash
	"Answer a SmallInteger whose value is related to the receiver's identity.
	This method must not be overridden, except by SmallInteger.
	
	Do not override."

	^ self basicIdentityHash bitShift: 18! !

!MARAbstractProxy methodsFor: 'initialize-release' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
initialize! !

!MARAbstractProxy methodsFor: 'testing' stamp: 'MarianoMartinezPeck 2/1/2012 15:45'!
isMeta
	^ false! !

!MARAbstractProxy methodsFor: 'message handling' stamp: 'MarianoMartinezPeck 2/1/2012 15:18'!
isNil
	^ false! !

!MARAbstractProxy methodsFor: 'hash' stamp: 'MarianoMartinezPeck 12/19/2011 09:34'!
largeIdentityHash
	<primitive: 75>
	self primitiveFailed! !

!MARAbstractProxy methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
mareaBasicIdentityHash
	"Answer a SmallInteger whose value is related to the receiver's identity.
	This method must not be overridden, except by SmallInteger.
	Primitive. Fails if the receiver is a SmallInteger. Essential.
	See Object documentation whatIsAPrimitive.

	Do not override. Use #identityHash unless you really know what you're doing.'"

	<primitive: 75>
	self primitiveFailed! !

!MARAbstractProxy methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
mareaBasicName
	^ 'aProxy'! !

!MARAbstractProxy methodsFor: 'class membership' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
mareaClass
	"Primitive. Answer the object which is the receiver's class. Essential. See 
	Object documentation whatIsAPrimitive."

	<primitive: 111>
	self primitiveFailed! !

!MARAbstractProxy methodsFor: 'message handling' stamp: 'MarianoMartinezPeck 12/17/2011 01:35'!
mareaHandler
	^ MARProxyHandler ! !

!MARAbstractProxy methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
mareaIdentityHash
	"Answer a SmallInteger whose value is related to the receiver's identity.
	This method must not be overridden, except by SmallInteger.
	
	Do not override."
	
	^ self mareaBasicIdentityHash bitShift: 18! !

!MARAbstractProxy methodsFor: 'testing' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
mareaIsProxy
	^ true! !

!MARAbstractProxy methodsFor: 'testing' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
mareaIsProxyInstalled
	^ self subclassResponsibility ! !

!MARAbstractProxy methodsFor: 'logging' stamp: 'MarianoMartinezPeck 12/17/2011 01:39'!
mareaLog: anObject
	MARLogger logger log: anObject.! !

!MARAbstractProxy methodsFor: 'enumerating' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
mareaNextInstance
	"Primitive. Answer the next instance after the receiver in the 
	enumeration of all instances of this class. Fails if all instances have been 
	enumerated. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 78>
	^nil! !

!MARAbstractProxy methodsFor: 'message handling' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
mareaPerform: selector withArguments: argArray inSuperclass: lookupClass
	"NOTE:  This is just like perform:withArguments:, except that
	the message lookup process begins, not with the receivers's class,
	but with the supplied superclass instead.  It will fail if lookupClass
	cannot be found among the receiver's superclasses.
	Primitive. Essential. See Object documentation whatIsAPrimitive."

	<primitive: 100>
	(selector isSymbol)
		ifFalse: [^ self error: 'selector argument must be a Symbol'].
	(selector numArgs = argArray size)
		ifFalse: [^ self error: 'incorrect number of arguments'].
	(self class == lookupClass or: [self class inheritsFrom: lookupClass])
		ifFalse: [^ self error: 'lookupClass is not in my inheritance chain'].
	self primitiveFailed! !

!MARAbstractProxy methodsFor: 'printing' stamp: 'MarianoMartinezPeck 12/15/2011 15:49'!
mareaPrintString
	^ 'This is the print of a proxy of class: ',  self mareaClass name asString, ', graphID: ', self mareaGraphID asString , ' and position: ', self mareaPosition asString. ! !

!MARAbstractProxy methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
mareaUninstall
	^ self mareaHandler uninstallForProxy: self
! !

!MARAbstractProxy methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 12/8/2011 17:09'!
mareaUninstallIfNeeded
	^ self mareaHandler uninstallIfNeeded: self
! !

!MARAbstractProxy methodsFor: 'message handling' stamp: 'MarianoMartinezPeck 2/1/2012 15:21'!
notNil
    ^ true! !

!MARAbstractProxy methodsFor: 'serialization' stamp: 'MarianoMartinezPeck 2/1/2012 14:54'!
removeDependent: anObject! !

MARAbstractProxy subclass: #MARClassProxy
	instanceVariableNames: 'superclass methodDict format proxyID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Proxies'!

!MARClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/17/2011 01:34'!
initialize
	"If you change this, change also #mareaIsWellInitialized"
	superclass := MARClassProxyInterceptor.
	methodDict := nil.
	format := Object format! !

!MARClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/1/2012 15:38'!
isKindOf: aClass
	^ (aClass == Class) 
		ifTrue: [ true ]
		ifFalse: [ super isKindOf: aClass  ]! !

!MARClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2011 16:03'!
mareaGraphID
	^ proxyID bitAnd: 2r111111111111111! !

!MARClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2011 16:03'!
mareaIsProxyInstalled
	^ proxyID isNil not! !

!MARClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/17/2011 01:34'!
mareaIsWellInitialized
	^  ((methodDict == nil) and: [ format = Object format ]) and: [ superclass == MARClassProxyInterceptor ] ! !

!MARClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/13/2011 16:33'!
mareaMethodDict
	^ methodDict! !

!MARClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2011 16:03'!
mareaPosition
	^ proxyID >> 15 
	! !

!MARClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2011 16:03'!
mareaProxyID
	^ proxyID! !

!MARClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2011 16:03'!
mareaProxyID: aNumber
	proxyID := aNumber! !

!MARClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 11/30/2011 16:03'!
mareaSetPosition: aPosition setGraphID: aGraphID
	proxyID :=  (aGraphID bitAnd: 16rFFFF) bitOr: (aPosition << 15).
! !

!MARClassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/13/2012 12:48'!
sizeInMemory 
	^ 20! !

MARAbstractProxy subclass: #MARRegularObjectProxy
	instanceVariableNames: 'proxyID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Proxies'!

MARRegularObjectProxy subclass: #MARMetaclassProxy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Proxies'!

!MARMetaclassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/1/2012 15:38'!
isKindOf: aClass
	^ (aClass == Metaclass) 
		ifTrue: [ true ]
		ifFalse: [ super isKindOf: aClass  ]! !

!MARMetaclassProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 2/1/2012 15:36'!
isMeta
	^ true! !

!MARRegularObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/2/2011 15:10'!
mareaGraphID
	^ proxyID bitAnd: 2r111111111111111! !

!MARRegularObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/3/2011 10:05'!
mareaIsProxyInstalled
	^ proxyID isNil not! !

!MARRegularObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/2/2011 15:10'!
mareaPosition
	^ proxyID >> 15 
	! !

!MARRegularObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/2/2011 15:10'!
mareaProxyID
	^ proxyID! !

!MARRegularObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/3/2011 16:38'!
mareaProxyID: aNumber
	proxyID := aNumber! !

!MARRegularObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/3/2012 11:39'!
mareaSetPosition: aPosition setGraphID: aGraphID
	(aPosition > 65535) ifTrue: [ MARPositionBiggerThanMax new signal: 'MAREA_ERROR: The position of the proxy is bigger than the maximum. The graph cannot be swapped'. ].
	(aGraphID > 32767) ifTrue: [ MARGraphIDBiggerThanMax new signal: 'MAREA_ERROR: The graphID of the proxy is bigger than the maximum. The graph cannot be swapped'. ].
	proxyID :=  (aGraphID bitAnd: 16rFFFF) bitOr: (aPosition << 15).
! !

!MARRegularObjectProxy methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 1/13/2012 12:48'!
sizeInMemory 
	^ 8 ! !

!MARProxyTrap class methodsFor: 'initialize' stamp: 'MarianoMartinezPeck 12/8/2011 17:10'!
initialize
	self nilMethodDict ! !

!MARProxyTrap class methodsFor: 'method dictionary' stamp: 'MarianoMartinezPeck 12/8/2011 17:10'!
nilMethodDict
	methodDict := nil. ! !

Object subclass: #MARProxyCreator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Marea-Proxies'!

!MARProxyCreator class methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 12/20/2011 12:47'!
createProxyFor: anObject
	^ anObject newProxy! !

Object subclass: #MARProxyHandler
	instanceVariableNames: ''
	classVariableNames: 'MareaSerializer MethodsNotToIntercept'
	poolDictionaries: ''
	category: 'Marea-Proxies'!

!MARProxyHandler class methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 10/3/2011 14:55'!
debuggingMessagesToHandle
	| dict |
	dict := Dictionary new.
	dict at: #basicInspect put:#handleBasicInspect:.
	dict at: #inspect put:#handleInspect:.
	dict at: #inspectorClass put:#handleInspectorClass:.
	dict at: #defaultLabelForInspector put:#handleDefaultLabelForInspector:.
	dict at: #printStringLimitedTo: put: #handlePrintStringLimitedTo:.
	dict at: #printString put: #handlePrintString:.
	dict at: #longPrintOn:limitedTo:indent: put: #handleLongPrintOnLimitedToIndent:.
	dict at: #printOn: put: #handlePrintOn:.
	^ dict		! !

!MARProxyHandler class methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 12/2/2011 14:00'!
defaultMethodsNotToIntercept
	| dict |
	dict := Dictionary new.	
	dict addAll: self debuggingMessagesToHandle.
	dict addAll: self methodsMessagesToHandle.
"	dict addAll: self testSupportMessagesToHandle.
	dict addAll: self classProxyMessagesToHandle."
	^ dict
	
	! !

!MARProxyHandler class methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 10/2/2011 21:23'!
handleBasicInspect: anInterception
	"Create and schedule an Inspector in which the user can examine the 
	receiver's variables. This method should not be overriden."
	^ToolSet basicInspect: anInterception proxy! !

!MARProxyHandler class methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 10/2/2011 21:23'!
handleDefaultLabelForInspector: anInterception
	^ 'Proxy'! !

!MARProxyHandler class methodsFor: 'handle - methods' stamp: 'MarianoMartinezPeck 12/2/2011 14:01'!
handleFlushCache: anInterception
	^ anInterception target selector flushCache	 
		! !

!MARProxyHandler class methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 10/2/2011 21:23'!
handleInspect: anInterception
	"Create and schedule an Inspector in which the user can examine the receiver's variables."
	ToolSet inspect: anInterception proxy! !

!MARProxyHandler class methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 10/2/2011 21:23'!
handleInspectorClass: anInterception
	"Answer the class of the inspector to be used on the receiver.  Called by inspect; 
	use basicInspect to get a normal (less useful) type of inspector."

	^ Inspector! !

!MARProxyHandler class methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 12/17/2011 01:34'!
handleInterception: aMessage for: aProxy
	| answer oldObject interception |
	
	interception := MARInterception for: aMessage target: nil proxy: aProxy receiver: nil. 
	(self isMessageNotToIntercept: aMessage)
		ifTrue: [ ^ self manageMessageInternally: interception ]
	 	ifFalse: [ ^ self manageMessage: interception  ]
	
	
	"oldObject := self uninstallForProxy: aProxy.
	self mareaLog: 'The message will be sent to the original object'.
	answer := aMessage sendTo: oldObject.
	self mareaLog: 'The message: ', aMessage selector asString, ' was sent to the original object'.
	^ answer "
! !

!MARProxyHandler class methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 1/2/2012 16:28'!
handleInterception: aMessage for: aProxy receiver: aReceiver

	self mareaLog: 'This was a message for an instance whose class was profixied by: ', aProxy mareaPrintString.
	MARObjectGraphImporter new swapInGraphFor: aProxy.
	^ aReceiver perform: aMessage selector withArguments: aMessage arguments.

! !

!MARProxyHandler class methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 10/2/2011 21:23'!
handleLongPrintOnLimitedToIndent: anInterception
	! !

!MARProxyHandler class methodsFor: 'handle - methods' stamp: 'MarianoMartinezPeck 1/27/2012 16:25'!
handleMethodExecution: anInterception
	| targetCM |
	self mareaLog: 'message ', anInterception message selector, ' execution intercepted and will be forwarded'.
	targetCM := MARObjectGraphImporter new swapInGraphFor: anInterception proxy.
	^ targetCM valueWithReceiver: anInterception message arguments third arguments: anInterception message arguments second
	
! !

!MARProxyHandler class methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 10/2/2011 21:23'!
handlePrintOn: anInterception
	anInterception message arguments first nextPutAll: 'aProxy'  ! !

!MARProxyHandler class methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 10/2/2011 21:24'!
handlePrintString: anInterception
	^ anInterception proxy printStringLimitedTo: 50000! !

!MARProxyHandler class methodsFor: 'handle - debugging' stamp: 'MarianoMartinezPeck 12/13/2011 23:54'!
handlePrintStringLimitedTo: anInterception
	| proxy |
	proxy := anInterception proxy. 
	^ 'This is the print of a proxy of class: ',  proxy mareaClass name asString, ', graphID: ', proxy mareaGraphID asString , ' and position: ', proxy mareaPosition asString. ! !

!MARProxyHandler class methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 10/2/2011 15:23'!
isMessageNotToIntercept: aMessage
	^ self methodsNotToIntercept includesKey: aMessage selector  ! !

!MARProxyHandler class methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 1/3/2012 17:51'!
manageMessage: interception
	| target result |
	self mareaLog: 'The method ', interception message selector, ' will be forwarded'.

	target := MARObjectGraphImporter new swapInGraphFor: interception proxy.

"	target isCompiledMethod ifTrue: [
	self mareaLog: 'mes:', interception message asString.
	self mareaLog: 'targ: :', interception message arguments asString.
	 ]."
	
	result  := interception message sendTo: target.
	self mareaLog: 'The method was forwarded'.
	^ result
! !

!MARProxyHandler class methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 10/3/2011 10:31'!
manageMessageInternally: anInterception 
	self mareaLog: 'The method ', anInterception message selector, ' will NOT be forwarded by instead answer by the handler'.
	^ self perform: (self methodsNotToIntercept at: anInterception message selector) with: anInterception ! !

!MARProxyHandler class methodsFor: 'handle - methods' stamp: 'MarianoMartinezPeck 12/2/2011 14:01'!
methodsMessagesToHandle
	| dict |
	dict := Dictionary new.
	dict at: #flushCache put: #handleFlushCache:.
	dict at: #run:with:in: put: #handleMethodExecution:.
	^ dict
! !

!MARProxyHandler class methodsFor: 'proxy handling' stamp: 'MarianoMartinezPeck 12/9/2011 17:01'!
methodsNotToIntercept
	MethodsNotToIntercept isNil ifTrue: [ MethodsNotToIntercept := self defaultMethodsNotToIntercept ].
	^ MethodsNotToIntercept ! !

!MARProxyHandler class methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 12/17/2011 01:35'!
uninstallForProxy: aProxy
	^ self uninstallForProxy: aProxy ifNotInstalled: [ MARProxyIsNotInstalled signal: 'The proxy is not installed. '].! !

!MARProxyHandler class methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 12/17/2011 01:34'!
uninstallForProxy: aProxy ifNotInstalled: errorBLock
	| oldObject originalObject |
	
	self mareaLog: 'Starting to uninstall.'.
	aProxy mareaIsProxyInstalled ifFalse: [ 
		self mareaLog: 'The proxy is not installed'.
		errorBLock value ].
	
	MARObjectGraphImporter new swapInGraphFor: aProxy.
	
	"now oldObject points to the proxy and aProxy points to the old object"
	self mareaLog: 'The Proxy for ', aProxy mareaBasicName, ' was uninstalled.'.
	^ aProxy.  
! !

!MARProxyHandler class methodsFor: 'install-uninstall' stamp: 'MarianoMartinezPeck 12/17/2011 01:35'!
uninstallIfNeeded: aProxy
	^ [self uninstallForProxy: aProxy] on: MARProxyIsNotInstalled do: [].! !

!MARProxyHandler methodsFor: 'seeClassSide' stamp: 'MarianoMartinezPeck 10/2/2011 14:54'!
seeClassSide! !

!Object methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 7/12/2011 13:35'!
mareaBasicName
	| title |
	title := self class name.
	^ String streamContents: [:aStream| 
		aStream
			nextPutAll: (title first isVowel ifTrue: ['an '] ifFalse: ['a ']);
			nextPutAll: title
		
	]
! !

!Object methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 3/14/2011 19:42'!
mareaPrintString
	^ self printString! !

!Object methodsFor: '*Marea' stamp: 'MarianoMartinezPeck 12/20/2011 14:32'!
newProxy
	^ MARRegularObjectProxy newProxy! !
MARLogger initialize!
MARForwardingPointer initialize!
MARObjectProxyInterceptor initialize!
MARProxyTrap initialize!
MARClassProxyInterceptor initialize!
MARFuelCachedMareaSerializer initialize!
MARAbstractProxy initialize!
MARFuelFullGlobalMapper initialize!
